<?php 

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------
	
require_once(dirname(__FILE__)."/serverSettings.php"); // useful for short php snippets that personalize the page.
	
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta name="description" content="<?php echo $WEBAPP_DESCRIPTION; ?> Patchwork is about social image sharing." />
<meta name="keywords" content="<?php echo $WEBAPP_KEYWORDS; ?>,Patchwork,image,sharing" />
<meta name="author" content="<?php echo $WEBAPP_AUTHORS; ?>" />
<title><?php echo $WEBAPP_NAME; ?></title>
<!-- 
##
## (c)2010 Teague, Adam Kumpf and Matt Wolfe 
## questions? akumpf@teague.com
## Licensed under Creative Commons Attribution-Share Alike 3.0
## Use it, make it better, and let others do the same. 
##
-->

<!-- 
## This manages the login.  Check javascript variables for info about the user:
## [auth_loggedIn, auth_login, auth_email, auth_name, auth_loginMD5, auth_errorMessage] 
-->
<?php require "./openid/openidOutputInJS.php"; ?>


<link rel="icon" type="image/png" href="./ui/patchwork_favicon.png" />

<!-- CSS STYLE ELEMENTS (if you have lots of styles, put them in a seperate file and link to them instead). -->
<link  href="//fonts.googleapis.com/css?family=Cantarell:regular,italic,bold,bolditalic" rel="stylesheet" type="text/css" >
<style>
	*{
		/*font-family: Helvetica, sans-serif;*/
		margin: 0px;
		padding: 0px;
	}
	body {
		min-width: 860px;
		overflow: hidden;
		/* FONT */
		font-family: 'Cantarell', serif;
		font-size: 10px;
		font-style: normal;
		font-weight: 300;
		text-shadow: none;
		text-decoration: none;
		text-transform: none;
		letter-spacing: -0.067em;
		word-spacing: 0em;
		word-wrap: break-word;
		/*line-height: 1em;*/
	}
	.absObj {
		position: absolute;
	}
	/*
	 -moz-border-radius: 10px;
	 -webkit-border-radius: 10px;
	 border: 2px solid #555555;
	 */
	#lightOverlayScreen{
		position: absolute;
		top: 0px;
		left: 0px;
		width: 100%;
		height: 100%;
		background: rgba(0,0,0,.10);
		z-index: 1;
	}
	#darkOverlayScreen{
		position: absolute;
		top: 0px;
		left: 0px;
		width: 100%;
		height: 100%;
		background: rgba(0,0,0,.85);
		z-index: 9999;
		display: none;
	}
	#darkOverlayScreen2{
		position: absolute;
		top: 0px;
		left: 0px;
		width: 100%;
		height: 100%;
		background: rgba(0,0,0,.85);
		z-index: 999;
		display: none;
	}
	#addNewDiv{
		position: absolute;
		left: -390px;
		top: 0px;	
		width: 410px;
		height: 290px;
		color: #CCC;
		z-index: 10000;
		font-size: 12px;
	}
#addNewUserLogout {
position: absolute; 
left: 25px;
top: 0px;
font-size: 10px;
color: #4D4D4D;
padding-top: 4px;
z-index: 10;
}
	#addNewToggler {
		position: absolute;
		width: 20px;
		height: 20px;
		left: 390px;
		top: 0px;
		background: url('./ui/newpost_expand.png') no-repeat center center #FFFFFF;
		cursor: pointer;
	}
	#addNewContainer {
	position: absolute;
	top: 0px;
	left: 0px;
	width: 290px;
	height: 344px;
	background: #FFFFFF;
	padding-left: 50px;
	padding-right: 50px;
	}

	#addnewTitle {
	font-size: 10px;
	color: #D95B72;
	padding-top: 4px;
	}
	#addnewCaption {
	padding-top: 10px;
	font-size: 12px;
	}
	#addnewSubmit {
	width: 100px;
	height: 18px;
	color: #FFFFFF;
	background: #4D4D4D;
	text-align: center;
	padding-top: 1px;
	position: relative;
	font-size: 12px;
	top: -5px;
	left: 190px;
	cursor: pointer;
	}
#authLoginSubmit {
width: 100px;
height: 20px;
color: #FFFFFF;
background: #4D4D4D;
text-align: center;
padding-top: 2px;
position: relative;
font-size: 12px;
top: -22px;
left: 190px;
cursor: pointer;
}
	#addnewURL {
	color: #4D4D4D;
	margin-top: 10px;
	}
	#addnewPatchTitle {
	color: #4D4D4D;
	}
	#addnewCaption {
	color: #4D4D4D;
	}
	#bookmarkletDiv a{
		color: #4D4D4D;
	}
	#bookmarkletDiv{
	position: absolute;
	left: 50px;
	top: 305px;
	}	
#userAdminAvatar{
position: absolute;
left: 50px;
top: 250px;
height: 40px;
width: 40px;
}

#userAdminName{
position: absolute;
left: 100px;
top: 245px;
font-size: 12px;
color: #4D4D4D;
}

#feedbackLinkDiv{
position: absolute;
left: 0px;
width: 390px;
top: 340px;
height: 40px;
color: #3FA9F5;
cursor: pointer;
background: url('./ui/feedback_blue.png') no-repeat;
}

	#overlaySwatchesDiv {
		position: absolute;
		top: 103px;
		right: 514px;
		height: 430px;
		width: 340px;
		z-index: 1000;
		background: rgba(255,255,255,0.85);
		visibility: hidden;
		overflow: hidden;
	}
	.swatch {
		position: absolute;
		width: 80px;
		height: 80px;
		background: #FFFFFF;
		cursor: pointer;
	}
	#giantImageTitle {
		position: absolute;
		bottom: 30px;
		right: 60px;
		width: 900px;
		font-size: 90px;
		color: #FFFFFF;
		z-index: 1;
		text-align: right;
		font-style: bold;
		font-weight: 800;
		line-height: 90px;
	}
	#rightDiv {
		position: absolute;
		top: 0px;
		right: 60px;
		height: 100%;
		width: 450px;
		z-index: 1000;
	}
	#caption {
		position: absolute;
		left: 0px;
		top: 0px;
		width: 450px;
		background: rgba(255,255,255,0.85);
		height: 85px;
		z-index: 10;
	}
	#captionDate {
		float: right;
		font-size: 10px;
		color: #4D4D4D;
		margin: 5px;
		margin-bottom: 0px;
		margin-right: 10px;
	}
	#captionTitle {
		padding: 4px;
		padding-left: 10px;
		padding-bottom: 2px;
		font-size: 10px;
		color: #D95B72;
	}
	#captionAuthPhoto {
		float: left;
		width: 50px;
		height: 50px;
		margin: 12px;
		margin-top: 1px;
		margin-bottom: 5px;
		background: #FFFFFF;
	}
	#captionAuthPhotoImg {
		width: 50px;
		height: 50px;
		margin: 0px;
		padding: 0px;
	}
	#captionText {
		display: block;
		padding-top: 0px;
		font-size: 22px;
		line-height: 23px;
		max-height: 47px;
		overflow: hidden;
		vertical-align: top;
	}
	#captionAuthor {
		padding-top: 0px;
		font-size: 12px;
		color: #4D4D4D;
	}
	#colorBarA{
		position:absolute;
		top: 89px;
		left: 0px;
		height: 10px;
		background: url('./ui/dropdown_collapsed.png') no-repeat center center #D95B72;
		width: 148px;
		z-index: 10;
		cursor: pointer;
	}
	#colorBarB{
		position:absolute;
		top: 89px;
		left: 152px;
		height: 10px;
		background: url('./ui/dropdown_expanded.png') no-repeat center center #D95B72;
		width: 298px;
		z-index: 10;
		cursor: pointer;
	}
	#tools {
		position: absolute;
		left: 0px;
		top: 103px;
		width: 148px;
		background: rgba(255,255,255,0.85);
		height: 0px; /* 132px */
		font-size: 12px;
		/*display: none; /* start collapsed */
		overflow: hidden;
	}
	#tools a {
		text-decoration: none;
		color: #4D4D4D;
	}
	.tool{
		margin-left: 4px;
		padding-left: 4px;
		margin-top: 5px;
		padding-top: 5px;
		width: 134px;
		height: 20px;
		cursor: pointer;
		border: 1px rgba(255,255,255,0) solid;
		color: #4D4D4D;
	}
	.tool:hover{
		background: rgba(255,255,255,1);
		border: 1px #4D4D4D solid;
	}
	#comments {
		position: absolute;
		left: 152px;
		top: 99px;
		width: 358px;
		height: 200px;
		overflow-y: auto;
	}
	#commentsTopPad {
		width: 298px;
		height: 103px;
	}
	.comment {
		position: relative;
		display: block;
		width: 298px;
		background: rgba(255,255,255,0.85);
		margin-top: 4px;
		min-height: 60px; 
		overflow-x: hidden;
	}
	.commentAuthPhoto {
		position: absolute;
		right: 0px;
		top: 0px;
		width: 60px;
		height: 60px;
		background: #FFFFFF;
	}
	.commentAuthPhotoImg{
		width: 40px;
		height: 40px;
		padding-left: 10px;
		padding-top: 10px;
	}
	.commentText {
		width: 228px;
		font-size: 16px;
		padding-left: 10px;
		padding-top: 10px;
		color: #4D4D4D;
	}
	.commentPhoto {
		width: 290px;
		height: auto;
		padding: 4px;
		padding-bottom: 0px;
	border: 0;
	}
	.commentVideo {
		padding: 4px;
		padding-left: 2px;
		padding-bottom: 0px;
	}
	.commentAuthor {
		font-size: 12px;
		color: #B3B3B3;
		padding-left: 10px;
		padding-bottom: 5px;
	}
	#commentBottomPad {
		display: block;
		width: 298px;
		height: 164px;
	}
	#talkBack {
		position: absolute;
		left: 152px;
		bottom: 0px;
		width: 288px;
		background: #FFFFFF;
		height: 20px;
		visibility: hidden;
		overflow: hidden;
		padding-left: 10px;
	}
	#talkbackTitle {
		font-size: 10px;
		color: #D95B72;
		padding-top: 4px;
		cursor: pointer;
	}
	#talkbackCaption {
		padding-top: 20px;
		font-size: 12px;
		padding-bottom: 5px;
		color: #4D4D4D;
	}
	#talkbackSubmit {
		width: 100px;
		height: 20px;
		color: #FFFFFF;
		background: #4D4D4D;
		text-align: center;
		position: relative;
		font-size: 12px;
		top: -20px;
		left: 178px;
		cursor: pointer;
	}

#view_Patch {
display: block;
}

#view_History {
display: none;
z-index: 
}
#historyTitlebar {
position: absolute;
left: 0px;
top: 0px;
width: 450px;
height: 40px;
background: url('./ui/history_header.png') no-repeat center center #FFFFFF;
z-index: 10000;
}
#historyContentScroller{
position: absolute;
top: 40px;
bottom: 0px;
left: 0px;
width: 510px;
overflow-y: auto;
background: url('./ui/history_bg.png') repeat-y left top;
}
#historyModeList{
position: absolute;
left: 400px;
top: 10px;
width: 20px;
height: 20px;
background: url('./ui/history_list-active.png') no-repeat center center;
cursor: pointer;
}
#historyModeGrid{
position: absolute;
left: 423px;
top: 10px;
width: 20px;
height: 20px;
background: url('./ui/history_grid-disabled.png') no-repeat center center;
cursor: pointer;
}
#historyList{
position: absolute;
left: 0px;
top: 0px;
width: 450px;
background: #FFFFFF;
}
#historyGrid{
position: absolute;
left: 0px;
top: 0px;
width: 450px;
height: 720px;
background: #FFFFFF;
display: none;
}
.histGridPatchDiv {
position: absolute;
width: 100px;
height: 100px;
cursor: pointer;
}
.histGridPatchImg{
	max-width: 100px;
	max-height: 100px;
}
.histGridNumComments{
position: absolute;
top: -7px;
left: 41px;
width: 18px;
height: 20px;
text-align: center;
vertical-align: middle;
color: #4D4D4D;
background: url('./ui/history_grid_StichBubble-25.png') no-repeat top center;
}

.histListPatchDiv {
display: block;
width: 430px;
margin: 10px;
cursor: pointer;
}
.histListPatchTimestamp {
	font-size: 10px;
	color: #B3B3B3;
	padding-bottom: 10px;
	padding-top: 10px;
}
.histListPatchImg {
	width: 200px;
	height: auto;
}
.histListCommentTriangle {
width: 15px;
height: 10px;
background: url('./ui/history_triangle-23.png') no-repeat top right;
}
.histListComment {
background: #E6E6E6;
padding: 10px;
	font-size: 14px;
}
.histListAuthDiv{
display: inline-block;
vertical-align: top;
width: 50px;
background: #FFFFFF;
}
.histListAuthImg{
padding: 10px;
width: 30px;
height: 30px;
}
.histListAuthName{
display: inline-block;
color: #B3B3B3;
	vertical-align: top;
	margin-top: 10px;
	font-size: 12px;
}
.histListCommentLine {
display: block;
width: 100%;
	border-bottom: 1px solid #E6E6E6;	
}
.histListNumComments {
	margin: 10px;
	color: #4D4D4D;
}

#historyPageSelector{
position: fixed;
bottom: 0px;
right: 60px;
border-top: 1px solid #808080;
padding-top: 10px;
color: #808080;
width: 450px;
height: 30px;
z-index: 1000;
background: #FFFFFF;
}
.histPageSelSpanLink{
cursor: pointer;
}
.histPageSelSpanNoLink{
color: #D6D6D6;
}
.histPageSelSpanSelected{
color: #4D4D4D;
font-weight: 800;
}
#mainImage{
position: absolute;
left: 0px;
top: 0px;
min-width: 100%;
min-height: 100%;
}
#mainImage2{
position: absolute;
left: 0px;
top: 0px;
max-width: 100%;
max-height: 100%;
}

</style>

<script>
function avatarImgLoadError(el){
	el.src = "./db/media/avatars/wally.jpg";
}
</script>

</head>
<body style="background: #E6E6E6;" onresize="resizePageElements();">	 
<!-- PAGE CONTENT... -->
<div id="appContainer" style="background: #E6E6E6; position: absolute; top: 0px; left: 0px; width: 100%; height: 100%; overflow: none;">
	<!-- ############################################### -->
	<!-- ######## static App content goes here. ######## -->
	<!-- ############################################### -->
	<!-- TIPS & TRICKS
	Normal mouse/touch interaction is eaten up by default, so if you want the click to pass to element as normal -- such as 
	clicking on a text input to bring up the keyboard for text entry -- you'll need to call focus(); to unfocus later, call blur().
	EX: <input id="formInputField" type="text" name="n" onmousedown="$(this).focus();" ontouchstart="$(this).focus();"/>

	Child elements don't pass mouse/touch events to their parents by default, so if you make a DIV movable, but 
	then place something on it (like an image or text), the elements will not move when start your press on the child.
	To work around this, either place the image as background, or pass all click event through to parent (how?!).
	EX: <div id="uniqueObjID" class="absObj touchMY" style="background: url('./image.png'); height: 460px; width: 320px;">
	EX: ?? how to pass mouse event through automaticallly? (glass overlay?).
	-->

	<!-- fixed elements (background, containers, regions, etc.) -->
	<div id="darkOverlayScreen"></div>

	<div id="lightOverlayScreen" onclick="viewToggle();" style="cursor: pointer;"></div>

	<div id="darkOverlayScreen2" onclick="closeHistory();"></div>

<div id="addNewUserLogout"><?php if($auth_login){echo "<span id='addNewUsername'>$auth_fullname</span> | <a href='./openid/openidLogout.php' style='text-decoration: none; color: #3FA9F5;'>Logout</a>";}else{echo "<span onclick='addNewToggle();' style='cursor: pointer; color: #3FA9F5;'>";if($auth_hadCookie){echo "Request Membership";}else{echo "Login";} echo "</span>";} ?></div>

	<div id="addNewDiv">
		<div id="addNewToggler" onclick="addNewToggle();"></div>
		<div id="addNewContainer">
			<div style="<?php if($auth_login){echo "display: bock;";}else{echo "display: none;";} ?>">
				<div id="addnewTitle">NEW PATCH</div>
				<div id="addnewURL">Image URL</div>
				<input type='text' id='patch_addnew_imgURL' size='50' value="Find something pretty? Let's see it." style="height: 16px; width: 286px; color: #B3B3B3;" onfocus="addnewURLfocus();" onblur="addnewURLblur();"/><br/>
				<div style="background: #CCCCCC; width: 290px; height: 1px; margin-top: 10px; margin-bottom: 5px;"></div>
				<div id="addnewPatchTitle">Title</div>
				<input type='text' id='patch_addnew_title' size='50' maxlength="50" value='' style="height: 16px; width: 286px; color: #000000;"/><br/>
				<div id="addnewCaption">Comment</div>
				<input type='text' id='patch_addnew_caption' size='50' maxlength="50" value='' style="height: 16px; width: 286px; color: #000000;"/><br/>
				<br/>
				<div id="addnewSubmit" onclick="tryToSubmitAddnew();">Submit</div>
				<div style="background: #000000; width: 390px; height: 4px; position: absolute; top: 230px; left: 0px;"></div>
				<div id="userAdminAvatar"><img style='width: 40px; height: 40px;' src='./db/media/avatars/<?php echo md5($auth_login); echo ".jpg?".time(); ?>' onerror='avatarImgLoadError(this);' /></div>
				<div id="userAdminName">
					<?php echo $auth_fullname; ?><br/>
					<span style="color: #3FA9F5; font-size: 10px; line-height: 10px; padding: 0px; margin: 0px;">Change my picture<br/><span style="color: #B3B3B3; position: relative; top: -5px;">Use a square jpg, gif, or png. Less than 1MB</span></span>
					<div id='imageUploadDiv' style="opacity: 0.01; position: relative; top: -31px;">
						<form id='hiddenImageUpload' name='hiddenImageUpload' method='post' action='./xmlhttpreq/uploadAvatarImage.php' enctype='multipart/form-data'>
						<input id='hiddenImageUploadFile' type='file' name='filename' size='2' style='cursor: pointer;' accept='image/gif,image/png,image/jpeg' onclick='changeMyPicture();'/></form>
					</div>
				</div>
				<div id="bookmarkletDiv" title="drag me to your bookmarks toolbar!"><a onclick="alert('This is a bookmarklet.\n\nIt allows you to easily submit images to Patchwork from any page.\n\nTo use it, just drag it to your bookmarks toolbar and click on it any time you find a page you want to share. :)');" href="javascript:(function(){document.PATCHWORK_OPEN_ID='<?php if($auth_login){echo $auth_login;} ?>';document.PATCH_ENCODED_ID='<?php if($auth_login){echo md5($auth_login.$SECRET_WORD); }?>';document.PATCH_BASE_URL='<?php echo $SERVER_BASE; ?>';document.PATCH_USERNAME='<?php echo urlencode($auth_fullname); ?>';patch_script=document.createElement('SCRIPT');patch_script.type='text/javascript';patch_script.src='<?php echo $SERVER_BASE; ?>js/patch_bookmarklet.js?x='+(Math.random());document.getElementsByTagName('head')[0].appendChild(patch_script);})();" style="color: #3FA9F5; text-decoration: none;"><img src='./ui/bookmarkletHandle.png' style='border: 0px; margin-bottom: 2px;' /> +Patchwork</a><span style='color: #4D4D4D;'> // Drag me to your bookmarks toolbar.</span></div>
				<div id="feedbackLinkDiv" onclick="feedback_widget.show();"></div>
			</div>
			<div style="<?php if($auth_login){echo "display: none;";}else{echo "display: block;";} ?> padding-top: 3px;">
				<span style='color: #4D4D4D'>You are not currently logged in to Patchwork.</span><br/>
<div id='authErrorMessageDiv' style='color: #AA6666; padding-top: 10px; padding-bottom: 10px;'><span id='authErrorMessageSpan'></span><br/></br><span id='requestMembershipSpan' style='cursor: pointer; color: #3FA9F5;' onclick='requestMembership();'>Click here to request membership to this patchwork.</span></div>
				<form name='auth_form_openidlogin' action='./openid/openidLogin.php?login' method='post' style='padding-top: 10px;'>
				<span style='color: #4D4D4D;'>OpenID Login:</span><br/>
				<input type='text'id='openid_identifier' name='openid_identifier' size='28' value='username@gmail.com' style="height: 16px; width: 176px; color: #B3B3B3;" onfocus="authLoginFocus();" onblur="authLoginBlur();" />
				<div id="authLoginSubmit" onclick="document.auth_form_openidlogin.submit();">Submit</div>
				</form>
			</div>
		</div>
	</div>
	<div id="giantImageTitle" onclick="viewToggle();" style="cursor: pointer;"></div>
	<div id="rightDiv">
		<div id="view_Patch">
			<div id="caption">
				<div>
					<div id="captionDate"></div>
					<div id="captionTitle">Loading...</div>
				</div>
				<div>
					<div id="captionAuthPhoto"></div>
					<div>
						<div id="captionText"></div>
						<div id="captionAuthor"></div>
					</div>
				</div>
			</div>
			<div id="colorBarA" onclick="toggleTools();"></div>
			<div id="colorBarB" onclick="toggleComments();"></div>
			<div id="tools">
				<div id="toolSave" class="tool" style="background: url('./ui/tools_save.png') no-repeat right center;"><a id="saveThisImageLink" href="">Save this image</a></div>
				<div id="toolSource" class="tool" style="background: url('./ui/tools_source.png') no-repeat right center;"><a id="goToSourceLink" href="">Go to source</a></div>
				<div id="toolSimilar" class="tool" style="background: url('./ui/tools_similar.png') no-repeat right center;"><a id="similarImagesLink" href="">Similar images</a></div>
				<!--<div id="toolSwatches" class="tool" style="background: url('./ui/tools_swatches.png') no-repeat right center;" onclick="toggleShowSwatches();">Color swatches</div>-->
			</div>
			<div id="comments">
				<div id="commentContainer">
					<!-- comments go here... -->
				</div>
				<div id="commentBottomPad"></div>
			</div>
			<div id="talkBack" style="<?php if($auth_login){echo "visibility: visible;";} ?>">
				<div id="talkbackTitle" onclick="toggleTalkBack();">+ TALK BACK</div>
				<div id="talkbackCaption">Image URL, YouTube URL, or comment</div>
				<input type='text' id='patch_input_imgURL' size='50' value='http://' style="height: 16px; width: 274px; color: #B3B3B3;" onfocus="talkbackURLfocus();" onblur="talkbackURLblur();"/><br/>
				<div style="background: #CCCCCC; width: 278px; height: 1px; margin-top: 10px; margin-bottom: 10px;"></div>
				<?php if($auth_login){echo "<span style='font-size: 12px; color: #4D4D4D;'>Logged in: $auth_fullname</span>";} ?>
				<!--<input type='text' id='patch_input_name' size='28' value='Your Username' style="height: 16px; width: 164px; color: #B3B3B3;" onfocus="talkbackNameFocus();" onblur="talkbackNameBlur();"/>--><br/>
				<div id="talkbackSubmit" onclick="tryToSubmitTalkback();">Submit</div>
			</div>
		</div>

		<div id="view_History">
			<div id="historyTitlebar">
				<div id="historyModeList" onclick="viewHistoryAsList();" title="View as List"></div>
				<div id="historyModeGrid" onclick="viewHistoryAsGrid();" title="View as Grid"></div>
			</div>
			<div id="historyContentScroller">
				<div id="historyContent">
					<div id="historyList"></div>
					<div id="historyGrid"></div>
					<div id="historyPageSelector"></div>
				</div>
			</div>
		</div>

	</div>
	<div id="overlaySwatchesDiv"></div>


	<!-- movable objects (draggable via their classes) -->


	<!-- dynamicly updated content (labels, graphics, feedback, etc.) -->

	<!--
	<div><canvas id="mainImageCanvas" onclick="viewToggle();" width="640" height="480" style="position: fixed; left: 0px; top: 0px; width: 100%; height: 100%; background: #E6E6E6; color: #000000;">
		Womp, womp...
		Your browser doesn't support the HTML5 Canvas tag.<br/><br/>
		Please use a modern standards-compliant browser such as Firefox, Chrome, or Safari.
	</canvas></div>
	-->

	<img id="mainImage2" src="./ui/background.png"/>
	<img id="mainImage" src="./ui/background.png"/>

	<!-- ############################################ -->
	<!-- ######## end of static App content. ######## -->
	<!-- ############################################ -->
</div>

<!-- ################################################ -->
<!-- ######## dynamic App content goes here. ######## -->
<!-- ################################################ -->

<!-- 
## Add a nice set of javascript libraries to make prototyping and development easy/efficient.
## Includes: JQuery, Multitouch-fake, Multitouch-simplified, HTML5 Utils, Nav-simplifier, etc.  -->
<script type="text/javascript" src="./js/teagueproto.js"></script>

<!-- javascript in testing.. this is where the bulk of the code goes until it can be refined and placed in a separate file. -->
<script type="text/javascript" charset="utf-8">
//<![CDATA[
//
// some notes on using simplified multitouch:
// ----------------------------------------------------------------------------------------------
//  * basic multitouch functionality can be easily accomplished by setting the element's class:
//    >> touchMX   = allow multitouch movement in X direction
//    >> touchMY   = allow multitouch movement in Y direction
//    >> touchMRequiresTwo = require two fingers for Move X/Y interaction.
//    >> touchRot  = allow multitouch 2 finger rotation
//    >> touchSca  = allow multitouch 2 finger scalling
//    >> touchTop  = pull object to top when touched (in front of other elements).
//    >> boundMX   = bound the object's X movement (specify with attributes: minBX, maxBX).
//    >> boundMY   = bound the object's Y movement (specify with attributes: minBY, maxBY).
//    >> boundSca  = bound the object's scale (specify with attributes: minSca, maxSca).
// * you can get all of the touch data through the event (e)
//    >> e.touches[]               = array of touches (length can be used to know number of fingers)
//    >> e.touches[i].identifier   = id of element being touched 
//    >> e.touches[i].target       = the actual element being touched (if any)
//    >> e.touches[i].clientX      = the global X position of the touch point
//    >> e.touches[i].clientY      = the global Y position of the touch point
//    >> e.touches[i].target.posX  = the 'left+ xfm_tx' property of the element being touched
//    >> e.touches[i].target.posY  = the 'top + xfm_ty' property of the element being touched
// * you can nicely set the position of the touched element with setTouchedElementPos(x,y); 
// * there's also an array of movingObjects[] that automatically updates (handy for low-level stuff).
// * If you want to turn on simulated two finger interaction when using a mouse, do this:
//    >> touchFakeTwoFingerForMouseInput = true;
// * There is are shortcut helpers for making code more compact:
//    >> did("uniqueID");  // performs: document.getElementById("uniqueID");
// * Another way to use touch is to add functionality specific to a particular element (with a unique id attribute).
//    >> did("uniqueID").onTouchDown = function(info) { }; // Touch started           >> info has {x, y, s, r, ax, ay}
//    >> did("uniqueID").onTouchMove = function(info) { }; // Touch moved             >> info has {x, y, s, r, ax, ay}
//    >> did("uniqueID").onTouchUp   = function(info) { }; // Touch released/stopped  >> info has {x, y, s, r, ax, ay}
// ----------------------------------------------------------------------------------------------
//
/*
 //
 // example of hooking up some touch interaction to an output.
 //
 did("volKnob").onTouchDown = function (info) {
 // what to do when the object is first touched.
 }
 did("volKnob").onTouchMove = function (info) {
 // what to do when the object is moved.
 did("volDiv").innerHTML = "VOLUME: " + ((info.x-10)/2.0);
 }
 did("volKnob").onTouchUp = function (info) {
 // what to do when the object is released.
 }
 */	


<?php
	echo "        // ARE WE INSIDE TEAGUE? \n";
	echo "        var insideTeague = "; 
	$ip=$_SERVER['REMOTE_ADDR'];
	if($ip == "74.202.208.69"){
		echo "true;\n";
	}else{
		echo "false;\n";
	}
	
	echo "var auto_refresh = false;\n";
	if(isset($_GET['auto_refresh'])){
		echo "auto_refresh = true;\n";
	}
	
	?>

var allPatches = []; // new Array();

function getUserData(){
	console.log("Fetching data...");
	
	$.ajax({ url: "./xmlhttpreq/getPatchesXML.php", success: function(data){
		   //console.log(data);
		   parseDataAndAddToList(data);
	   }});
}

function parseDataAndAddToList(data){
	console.log("Parsing incoming Patch data.");
	var patchArray = $(data).find("patch");
	allPatches = []; // new Array();
	for(var i = 0; i<patchArray.length; i++){
		var patchID   = unescape($(patchArray[i]).attr("patchID"));
		var epochDate = unescape($(patchArray[i]).attr("epoch")).replace(/\+/g, " ");
		var url       = unescape($(patchArray[i]).attr("url"));
		var imageURL  = unescape($(patchArray[i]).attr("imageURL"));
		var title     = unescape($(patchArray[i]).attr("title")).replace(/\+/g, " ");
		var desc      = unescape($(patchArray[i]).attr("desc")).replace(/\+/g, " ");
		var user      = unescape($(patchArray[i]).attr("username")).replace(/\+/g, " ");
		var numComments = parseInt($(patchArray[i]).attr("numComments"));
		var userMD5   = unescape($(patchArray[i]).attr("userMD5"));
		var p = new Patch(patchID, epochDate, imageURL, url, title, desc, user, numComments, userMD5);
		allPatches.push(p);
	}
	console.log("Done with incomming data.");
	if(allPatches.length > 0){
		if(currentPatchID != allPatches[allPatches.length-1].patchID){
			showPatch(allPatches.length-1);
		}else{
			console.log("latest patch already being used.. no need to clear comments and redraw.");
		}
	}
}

// ---------------------------------------------------
// OpenID User Login
// ---------------------------------------------------
function authLoginFocus(){
	var userField = did('openid_identifier');
	if(userField.value == "username@gmail.com"){
		userField.value = "";
	}
	$("#openid_identifier").css({color: "#000000"});
}

function authLoginBlur(){
	var userField = did('openid_identifier');
	if(userField.value == ""){
		userField.value = "username@gmail.com";
		$(userField).css({color: "#B3B3B3"});
	}
}

function requestMembership(){
	console.log("requesting Membership.");
	<?php 
	if($auth_hadCookie){
	?>
		console.log("performing request.");
		$.get("./openid/openidAddRequest.php", {}, function(data){
			alert(data);
			  $("#requestMembershipSpan").fadeOut();
			  setTimeout(rebootWebapp, 1500);
			});
	<?php
	}
	?>
}

var checkingForImageToUpload = false;
function changeMyPicture(){
	console.log("changing image.");
	document.hiddenImageUpload.reset();
	if(!checkingForImageToUpload){
		setInterval(checkForNewPictureSelection, 1000);
		checkingForImageToUpload = true;
	}
}

function checkForNewPictureSelection(){
	if($('#hiddenImageUploadFile').length > 0){
		var flist = $('#hiddenImageUploadFile')[0].files;
		if(flist.length > 0){
			document.hiddenImageUpload.submit();
		}
	}
}

function rebootWebapp(){
	window.location.reload(true);	
}
// ---------------------------------------------------
// History/Patch views
// ---------------------------------------------------
var viewingHistory = false;
function viewToggle(){
	console.log("toggling view.");
	if(viewingHistory){
		closeHistory();
	}else{
		openHistory();
	}
}
function openHistory(){
	viewingHistory = true;
	hideSwatches();
	$("#view_History").fadeIn();
	$("#darkOverlayScreen2").show();
	$("#talkBack").hide();
	$("#view_Patch").fadeOut();
	if(historyViewIsList){
		viewHistoryAsList();
	}else{
		viewHistoryAsGrid();
	}
	setTimeout(populateHistoryViews, 500);
}
function closeHistory(){
	viewingHistory = false;
	$("#view_History").hide();
	$("#darkOverlayScreen2").fadeOut();
	$("#talkBack").show();
	$("#view_Patch").show();
}

var historyViewIsList = true;
function viewHistoryAsList(){
	historyViewIsList = true;
	$("#historyList").show();
	$("#historyGrid").hide();
	$("#historyModeList").css({background: "url('./ui/history_list-active.png') no-repeat center center"});
	$("#historyModeGrid").css({background: "url('./ui/history_grid-disabled.png') no-repeat center center"});
}
function viewHistoryAsGrid(){
	historyViewIsList = false;
	$("#historyList").hide();
	$("#historyGrid").show();
	$("#historyModeList").css({background: "url('./ui/history_list-disabled.png') no-repeat center center"});
	$("#historyModeGrid").css({background: "url('./ui/history_grid-active.png') no-repeat center center"});
}
function populateHistoryViews(){
	// make list page...
	var listHTML = "";
	for(var i=0; i<HIST_RESULTS_PER_PAGE; i++){
		var index = (allPatches.length-1) - (i +  historyPage*HIST_RESULTS_PER_PAGE);
		if(index < allPatches.length && index >= 0){
			var patch = allPatches[index];
			var niceTitle = patch.title.replace("'", "");				
			var left = 10 + (i%4) * 110;
			var top = 20 + Math.floor(i/4) * 110;
			listHTML += "<div class='histListPatchDiv' onclick='showPatchFromHistoryView("+index+");' title='"+niceTitle+"'><div class='histListPatchTimestamp'>"+patch.getNiceDate()+" &mdash; "+patch.title.toUpperCase()+"</div>";
			listHTML += "<table style='margin: 0px; padding: 0px;' cellspacing='0' cellpadding='0'><tr><td width='200' style='vertical-align: top;'><img class='histListPatchImg' src='"+patch.imageURL+"' /></td>";
			listHTML += "<td width='10' style='vertical-align: top;'><div class='histListCommentTriangle'></div></td>";
			listHTML += "<td style='vertical-align: top;' width='100%'>";
			listHTML += "<div class='histListComment'>"+patch.desc+"</div>";
			listHTML += "<div class='histListAuthDiv'><img class='histListAuthImg' src='./db/media/avatars/"+patch.userMD5+".jpg?"+pageLoadTime+"' onerror='avatarImgLoadError(this);'/></div><div class='histListAuthName'>"+patch.user+"</div>";
			listHTML += "<div class='histListCommentLine'></div>";
			if(patch.numComments > 0){
				listHTML += "<div class='histListNumComments'>"+patch.numComments+" more stiches</div>";
			}
			listHTML += "</td></table></div>"; 
		}
	}
	listHTML += "<div style='padding-bottom: 40px'>&nbsp;</div>";
	did("historyList").innerHTML = listHTML;
	
	// make grid page...
	var gridHTML = "";
	for(var i=0; i<HIST_RESULTS_PER_PAGE; i++){
		var index = (allPatches.length-1) - (i +  historyPage*HIST_RESULTS_PER_PAGE);
		if(index < allPatches.length && index >= 0){
			var patch = allPatches[index];
			var niceTitle = patch.title.replace("'", "");				
			var left = 10 + (i%4) * 110;
			var top = 20 + Math.floor(i/4) * 110;
			gridHTML += "<div class='histGridPatchDiv' onclick='showPatchFromHistoryView("+index+");' style='left: "+left+"px; top: "+top+"px;' title='"+niceTitle+"'>";
			gridHTML += "<center><img class='histGridPatchImg' src='"+patch.imageURL+"' /></center>"; 
			if(patch.numComments > 0){
				gridHTML += "<div class='histGridNumComments'>"+patch.numComments+"</div>";
			}
			gridHTML += "</div>";
		}
	}
	did("historyGrid").innerHTML = gridHTML;
	
	// make historyPageSelector
	var selHTML = "";
	var lastPage = allPatches.length/HIST_RESULTS_PER_PAGE;
	if(historyPage > 0){
		selHTML += "<span class='histPageSelSpanLink' onclick='histGotoPage("+(historyPage-1)+");' style='position: absolute; left: 10px;'>VIBRANT</span>";
	}else{
		selHTML += "<span class='histPageSelSpanNoLink' style='position: absolute; left: 10px;'>VIBRANT</span>";
	}
	for(var i=-12; i<0; i++){
		var index = (i+historyPage);
		if(index >= 0){
			selHTML += "<span class='histPageSelSpanLink' onclick='histGotoPage("+index+");' style='position: absolute; left: "+(225+i*14)+"px;'>"+(index+1)+"</span>";
		}
	}
	selHTML += "<span class='histPageSelSpanSelected' style='position: absolute; left: 225px;'>"+(historyPage+1)+"</span>";
	for(var i=1; i<=12; i++){
		var index = historyPage + i;
		if(index < lastPage){
			selHTML += "<span class='histPageSelSpanLink' onclick='histGotoPage("+index+");' style='position: absolute; left: "+(225+i*14)+"px;'>"+(index+1)+"</span>";
		}
	}
	if(historyPage < lastPage-1){
		selHTML += "<span class='histPageSelSpanLink' onclick='histGotoPage("+(historyPage+1)+");' style='position: absolute; right: 10px;'>FADED</span>";
	}else{
		selHTML += "<span class='histPageSelSpanNoLink' style='position: absolute; right: 10px;'>FADED</span>";
	}
	selHTML += "";
	did("historyPageSelector").innerHTML = selHTML;
}

function showPatchFromHistoryView(pIndex){
	if(pIndex < allPatches.length && pIndex >= 0){
		showPatch(pIndex);
		closeHistory();
	}
}

var HIST_RESULTS_PER_PAGE = 24;
var historyPage = 0;
function histGotoPage(p){
	if(p >= 0 && p < allPatches.length/HIST_RESULTS_PER_PAGE){
		historyPage = p;
		populateHistoryViews();
	}
}

// ---------------------------------------------------
// Add New (upper left)
// ---------------------------------------------------
var addNewIsOpen = false;
function addNewToggle(){
	console.log("toggling add new.");
	if(addNewIsOpen){
		closeAddNew();
	}else{
		openAddNew();
	}
}
function closeAddNew(){
	addNewIsOpen = false;
	console.log("closing Add new.");
	$("#addNewToggler").css({background: "url('./ui/newpost_expand.png') no-repeat center center #FFFFFF"});
	$("#addNewDiv").animate({left: "-390px"});
	$("#darkOverlayScreen").css({display: "none"});
}
function openAddNew(){
	addNewIsOpen = true;
	console.log("opening Add new.");
	$("#addNewToggler").css({background: "url('./ui/newpost_collapse.png') no-repeat center center #FFFFFF"});
	$("#addNewDiv").animate({left: "0px"});
	$("#darkOverlayScreen").css({display: "block"});
}

function addnewURLfocus(){
	var urlOrText  = did('patch_addnew_imgURL').value;
	if(urlOrText == "Find something pretty? Let's see it."){
		did('patch_addnew_imgURL').value = "";
	}
	$("#patch_addnew_imgURL").css({color: "#000000"});
}
function addnewURLblur(){
	var urlOrText  = did('patch_addnew_imgURL').value;
	if(urlOrText == ""){
		did('patch_addnew_imgURL').value = "Find something pretty? Let's see it.";
		$("#patch_addnew_imgURL").css({color: "#B3B3B3"});
	}
}
function tryToSubmitAddnew(){
	console.log("Posting new image...");
	var url     = did('patch_addnew_imgURL').value;
	var user    = auth_name; //did('patch_addnew_name').value; [[ login, email, name, auth_loggedIn ]]
	var caption = did('patch_addnew_caption').value;
	var title   = did('patch_addnew_title').value;
	if(url == "" || url == "Find something pretty? Let's see it." || url.indexOf("http://") < 0){
		alert("Your patch doesn't include a URL (starting with http://).\n\nPlease try again. ");
		return;
	}
	if(user == "" || user == "Your Username"){
		user = "Anonymous";
	}
	closeAddNew();
	if(auth_loggedIn){
		$.get("./xmlhttpreq/addNewPatch.php", { url: "", title: title, desc: caption, username: user, imageURL: url, openID: auth_login, encodedOpenID: "<?php if($auth_login){echo md5($auth_login.$SECRET_WORD); }?>"}, function(data){
			  setTimeout(getUserData, 3000);
			  setTimeout(getUserData, 6000);
			  alert(data);
			  });
		did('patch_addnew_imgURL').value = "Find something pretty? Let's see it.";
		//did('patch_addnew_name').value = "Your Username";
		did('patch_addnew_caption').value = "";
		did('patch_addnew_title').value = "";
		addnewURLblur();
	}else{
		console.log("whah?  user is not even logged in..  :(");
	}
}




// ---------------------------------------------------
// Tools
// ---------------------------------------------------
var toolsAreOpen = false;
function toggleTools(){
	if(toolsAreOpen){
		closeTools();
	}else{
		openTools();
	}
}
function closeTools(){
	toolsAreOpen = false;
	hideSwatches();
	$("#colorBarA").css({background: "url('./ui/dropdown_collapsed.png') no-repeat center center #D95B72"});
	//$("#tools").css({display: "none"});
	$("#tools").animate({height: "0px"}, "fast");
	
}
function openTools(){
	toolsAreOpen = true;
	$("#colorBarA").css({background: "url('./ui/dropdown_expanded.png') no-repeat center center #D95B72"});
    $("#tools").css({display: "block"});
	$("#tools").animate({height: "100px"}, "fast"); // was 132px;
}


// ---------------------------------------------------
// Comments
// ---------------------------------------------------
var commentsAreOpen = true;
function toggleComments(){
	if(commentsAreOpen){
		closeComments();
	}else{
		openComments();
	}
}
function closeComments(){
	commentsAreOpen = false;
	$("#colorBarB").css({background: "url('./ui/dropdown_collapsed.png') no-repeat center center #D95B72"});
	//$("#comments").css({display: "none"});
	$("#comments").animate({height: "0px"});
	
}
function openComments(){
	commentsAreOpen = true;
	$("#colorBarB").css({background: "url('./ui/dropdown_expanded.png') no-repeat center center #D95B72"});
	//$("#comments").css({display: "block"});
	var winH = $(window).height();
	$("#comments").animate({height: (winH-99)+"px"});
}

// ---------------------------------------------------
// Patches and Comments
// ---------------------------------------------------
var COMMENT_REFRESH_TIME = 30000;
var currentPatchID = 0;
function showPatch(index){
	console.log("Loading patch: " + index);
	if(index >= 0 && allPatches.length > index){
		var patch = allPatches[index];
		did("mainImage").setAttribute("src", patch.imageURL);
		did("captionDate").innerHTML = patch.getNiceDate();
		did("captionTitle").innerHTML = patch.title.toUpperCase();
		did("giantImageTitle").innerHTML = patch.title.toUpperCase();
		did("captionText").innerHTML = patch.desc;
		did("captionAuthor").innerHTML = patch.user;
		did("captionAuthPhoto").innerHTML = "<img id='captionAuthPhotoImg' src='./db/media/avatars/"+patch.userMD5+".jpg?"+pageLoadTime+"' onerror='avatarImgLoadError(this);' title='"+patch.user+"' />";
		
		did("saveThisImageLink").setAttribute("href", patch.imageURL);
		did("similarImagesLink").setAttribute("href", "http://www.gazopa.com/similar?category=flickr_r&key_url="+escape(patch.imageURL));
		var url = unescape(patch.url);
		if(url == ""){
			url = "http://"
		}
		did("goToSourceLink").setAttribute("href", url);
		
		currentPatchID = allPatches[index].patchID;
		
		currentComments = [];
		sizeOfCommentsAtLastUpdate = 0;
		did("commentContainer").innerHTML = "";
		getCurrentPatchComments();
		
		setTimeout(resizePageElements, 500);
	}
}

function linkify(inputText) {
	//URLs starting with http://, https://, or ftp://
	var replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
	var replacedText = inputText.replace(replacePattern1, '<a href="$1" target="_blank">$1</a>');

	//URLs starting with www. (without // before it, or it'd re-link the ones done above)
	var replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
	var replacedText = replacedText.replace(replacePattern2, '$1<a href="http://$2" target="_blank">$2</a>');

	//Change email addresses to mailto:: links
	var replacePattern3 = /(\w+@[a-zA-Z_]+?\.[a-zA-Z]{2,6})/gim;
	var replacedText = replacedText.replace(replacePattern3, '<a href="mailto:$1">$1</a>');

	return replacedText;
}
							
function fadeMeIn(el){
	$(el).fadeIn();
}
							

var sizeOfCommentsAtLastUpdate = 0;
function updateComments(){
	if(sizeOfCommentsAtLastUpdate < currentComments.length){
		var commentsHTML = "";
		for(var i=sizeOfCommentsAtLastUpdate; i<currentComments.length; i++){
			var c = currentComments[i];
			commentsHTML += "<div class='comment' id='commentNum_"+i+"' style='display: none;'>";
			commentsHTML += "<div class='commentAuthPhoto' title='"+c.user+"'><img class='commentAuthPhotoImg' src='./db/media/avatars/"+c.userMD5+".jpg?"+pageLoadTime+"' onerror='avatarImgLoadError(this);'/></div>";
			if(c.isURL){
				if(c.isImg){
					var ytPos = c.comment.indexOf("youtube.com");
					if(ytPos > 0){
						// count it as youtube!
						//RUC2tpY5gb4
						var youtubeURL = c.comment.substr(ytPos);
						console.log(youtubeURL);
						var youtubeID = "RUC2tpY5gb4";
						var idLoc = c.comment.indexOf("watch?v=");
						if(idLoc > 0){
							var idStr = c.comment.substr(idLoc);
							var idEndLoc = idStr.indexOf("&");
							if(idEndLoc > 9){
								youtubeID = idStr.substr(8, idEndLoc-8);
								console.log("A >> " + youtubeID);
							}else{
								youtubeID = idStr.substr(8);
								console.log("B >> " + youtubeID);
							}
						}
						commentsHTML += "<div class='commentVideo'><object width='290' height='236' class='commentVideo'><param name='movie' value='http://www.youtube.com/v/"+youtubeID+"&amp;hl=en_US&amp;fs=1?rel=0'></param><param name='allowFullScreen' value='true'></param><param name='allowscriptaccess' value='always'></param><embed src='http://www.youtube.com/v/"+youtubeID+"&amp;hl=en_US&amp;fs=1?rel=0' type='application/x-shockwave-flash' allowscriptaccess='always' allowfullscreen='true' width='290' height='236'></embed></object></div>";
					}else{
						commentsHTML += "<a href='"+c.comment+"'><img class='commentPhoto' src='"+c.comment+"' /></a>";
					}
				}else{
					commentsHTML += "<div class='commentText'>"+linkify(c.comment.replace(/\+/g, ' '))+"</div>";
					commentsHTML += "<div class='commentAuthor'>"+c.user+"</div>";
				}
			}else{
				commentsHTML += "<div class='commentText'>"+c.comment+"</div>";
				commentsHTML += "<div class='commentAuthor'>"+c.user+"</div>";
			}
			commentsHTML += "</div>";
		}
		did("commentContainer").innerHTML += commentsHTML;
		setTimeout(scrollCommentsToEnd, 3000);
		for(var i=sizeOfCommentsAtLastUpdate; i<currentComments.length; i++){
			// fade in the comments that were just added.
			$("#commentNum_"+i).fadeIn();
		}
	}
	sizeOfCommentsAtLastUpdate = currentComments.length;
}
	
function scrollCommentsToEnd(){
	var scrollDest = Math.max(0, did("comments").scrollHeight-160-($(window).height()-117));
	//console.log("trying scroll: was " + did("comments").scrollHeight + ", going to " + scrollDest);
	$("#comments").animate({scrollTop: scrollDest}, "slow"); // = (did("commentContainer").scrollHeight-200);
}

var currentComments = [];

function getCurrentPatchComments(){
	console.log("getting comments for current patch.");
	
	$.ajax({ url: "./xmlhttpreq/getPatchCommentsXML.php?patch="+currentPatchID, success: function(data){
		   //console.log(data);
		   parseComments(data);
		   updateComments();
		   }});
}

function parseComments(data){
	//console.log("Parsing comments...");
	currentComments = [];
	var commentsArray = $(data).find("comment");
	for(var i = 0; i<commentsArray.length; i++){
		var epochDate = unescape($(commentsArray[i]).attr("epoch")).replace(/\+/g, " ");
		var user      = unescape($(commentsArray[i]).attr("user")).replace(/\+/g, " ");
		var comment   = unescape($(commentsArray[i]).attr("comment"));
		var userMD5   = unescape($(commentsArray[i]).attr("userMD5"));
		//console.log("Comment: " + comment);
		var commentIsURL = false;
		if(comment.indexOf("http") >= 0){
			//console.log("Setting as URL. Index was: " + comment.indexOf("http"));
			commentIsURL = true;
		}
		if(!commentIsURL){
			// it's a text comment.. turn the + signs back to spaces...
			comment = comment.replace(/\+/g, " ");
		}
		var isImg = false;
		if(comment.indexOf("http") == 0){
			// TODO: actually determine if link is a page or an image.
			isImg = true;
		}
		var c = new Comment(epochDate, commentIsURL, user, comment, isImg, userMD5);
		currentComments.push(c);
	}
	setCommentCountForCurrentPatch(currentComments.length);
}
							
function setCommentCountForCurrentPatch(c){
	for(var i=0; i<allPatches.length; i++){
		var patch = allPatches[i];
		if(patch.patchID == currentPatchID){
			patch.numComments = c;
		}
	}
}

function Patch(patchID, epoch, imageURL, url, title, desc, user, numComments, userMD5){
	this.patchID = patchID;
	this.epoch = epoch;
	this.url = url;
	this.title = title;
	this.desc = desc;
	this.imageURL = imageURL;
	this.user = "Anonymous";
	if(user != "undefined"){
		this.user = user;
	}
	this.userMD5 = userMD5;
	this.numComments = numComments;
	this.comments = [];
	function addCommentToPatch(comment){
		this.comments.push(comment);
	}
	this.getNiceDate = function(){
		var date = new Date(this.epoch*1000);
		var dateY = (date.getYear()-100);
		var dateM = (date.getMonth()+1);
		var dateD = date.getDate();
		if(dateY < 10){
			dateY = "0" + dateY;
		}
		if(dateM < 10){
			dateM = "0" + dateM;
		}
		if(dateD < 10){
			dateD = "0" + dateD;
		}
		return "" + dateM + " / " + dateD + " / " + dateY;
	}
}

function Comment(epoch, isURL, user, comment, isImg, userMD5){
	this.epoch = epoch;
	this.isURL = isURL;
	this.isImg = isImg;
	this.user = user;
	this.comment = comment;
	this.userMD5 = userMD5;
}

							

/* TOUCH CALLBACKS */
// These enable you to do more advanced things with touches if you want.. not necessary for move/scale/rotate.
//*
function touchStart(e){
	// put code here that gets called when a touch is started (finger first touches the screen).
}
function touchMove(e){
	// put code here that gets called when a touch is moved (finger dragged on the screen).
}
function touchEnd(e){
	// put code here that gets called when a touch is ended (finger lifted from screen). 
	// (movingObjects[id] have been deleted at this point; use the onTouchDown attribute to catch the release earlier).
	// this can be a good place to check for bounds of moved objects and spring them back if needed.
}
function touchCancel(e){
	// put code here that gets called when a touch is cancelled (not sure how this is different from End).
	// (movingObjects[id] have been deleted at this point; use the onTouchDown attribute to catch the release earlier).
	touchEnd(e);
}
//*/

function imageIsOk(img) {
	// During the onload event, IE correctly identifies any images
	// that weren't downloaded as not complete. Others should too.
	// Gecko-based browsers act like NS4 in that they report this
	// incorrectly: they always return true.
	if (!img.complete) {
		return false;
	}
	// However, they do have two very useful properties: naturalWidth
	// and naturalHeight. These give the true size of the image. If
	// it failed to load, either of these should be zero.
	if (typeof img.naturalWidth != "undefined" && img.naturalWidth == 0) {
		return false;
	}
	//console.log("size was computed okay...");
	// No other way of checking: assume it's ok.
	return true;
}
							
							
var stretchStyleIsFull = false;

function resizePageElements(){
	
//	var canvas = document.getElementById("mainImageCanvas");
//	var ctx = canvas.getContext("2d"); 
//	$(canvas).css({width: "100%", height: "100%"});
	var winW = $(window).width();
	var winH = $(window).height();
	
	$("#rightDiv").css({left: (Math.max(900, winW)-510)+"px"});
	$("#comments").css({height: (winH-99)+"px"});
	
	/*
	canvas.setAttribute("width", winW);
	canvas.setAttribute("height", winH);
	var img = did("mainImage");
	if(!imageIsOk(img)){
		console.log("mainImage not loaded yet... trying background (will try again shortly).");
		setTimeout(resizePageElements, 1000);
		img = did("mainImage2");
		if(!imageIsOk(img)){
			console.log("waiting on image load...");
			return;
		}
	}
	var imgW = $(img).width();
	var imgH = $(img).height();
	var s1 = winW/imgW;
	var s2 = winH/imgH;
	var scale = s1;
	if(stretchStyleIsFull){
		ctx.drawImage(img, 0, 0, winW, winH);
	}else{
		if(s1 > s2){
			ctx.drawImage(img, 0, -(imgH*s1-winH)/2, imgW*s1, imgH*s1);
		}else{
			ctx.drawImage(img, -(imgW*s2-winW)/2, 0, imgW*s2, imgH*s2);
		}
	}
	*/
	
}


// ---------------------------------------------------
// Talk Back
// ---------------------------------------------------
var talkbackIsShown = false;
function toggleTalkBack(){
	if(talkbackIsShown){
		hideTalkBack();
	}else{
		showTalkBack();
	}
}
function hideTalkBack(){
	$("#talkBack").animate({height: "20px"}, "fast");
	talkbackIsShown = false;
}
function showTalkBack(){
	talkbackIsShown = true;
	$("#talkBack").animate({height: "160px"}, "fast");
}

function talkbackURLfocus(){
	var urlOrText  = did('patch_input_imgURL').value;
	if(urlOrText == "http://"){
		did('patch_input_imgURL').value = "";
	}
	$("#patch_input_imgURL").css({color: "#000000"});
}
function talkbackURLblur(){
	var urlOrText  = did('patch_input_imgURL').value;
	if(urlOrText == ""){
		did('patch_input_imgURL').value = "http://";
		$("#patch_input_imgURL").css({color: "#B3B3B3"});
	}
}
function tryToSubmitTalkback(){
	console.log("Posting comment...");
	var text = did('patch_input_imgURL').value;
	var user = auth_name; //did('patch_input_name').value;
	if(text == "" || text == "http://"){
		alert("Your comment doesn't include any text.\n\nLet's try a little harder next time, yeah?\n");
		return;
	}
	if(user == "" || user == "Your Username"){
		user = "Anonymous";
	}
	
	$.get("./xmlhttpreq/addCommentToPatch.php", { patch: currentPatchID, user: user, comment: text, openID: auth_login, encodedOpenID: "<?php if($auth_login){echo md5($auth_login.$SECRET_WORD); }?>" }, function(data){
		  //alert(data);
		  hideTalkBack();
		  //did('patch_input_name').value = "Your Username";
		  //$("#patch_input_name").css({color: "#B3B3B3"});
		  did('patch_input_imgURL').value = "http://";
		  $("#patch_input_imgURL").css({color: "#B3B3B3"});
		  setTimeout(getCurrentPatchComments, 500);
		  });
}

// ---------------------------------------------------
// Swatches
// ---------------------------------------------------
var latestSwatches = [];
function Swatch(origX, origY, r,g,b,a){
	this.origX = origX;
	this.origY = origY;
	this.r = r;
	this.g = g;
	this.b = b;
	this.a = a;
	this.getHex = function(){
		var nR = this.r.toString(16);
		if(nR.length < 2){
			nR = "0"+nR;
		}
		var nG = this.g.toString(16);
		if(nG.length < 2){
			nG = "0"+nG;
		}
		var nB = this.b.toString(16);
		if(nB.length < 2){
			nB = "0"+nB;
		}
		return ""+nR+nG+nB;
	}
	this.getPrettyRGB = function(){
		return "RGB("+this.r+","+this.g+","+this.b+")";
	}
	this.getLuminance = function(){
		return (0.3*this.r + 0.59*this.g + 0.11*this.b); //sqrt( 0.241*r^2 + 0.691*g^2 + 0.068*b^2); ??
	}
	this.getSaturation = function(){
		return Math.max(this.r, Math.max(this.g, this.b)) - Math.min(this.r, Math.min(this.g, this.b));
	}
	this.getHue = function(){
		return (Math.sqrt(3)*(this.g-this.b))/(2*this.r-this.g-this.b);
	}
}
function toggleShowSwatches(){
	var swatchesDiv = did("overlaySwatchesDiv");
	if($(swatchesDiv).css("visibility") == "hidden"){
		showCurrentSwatches();
	}else{
		hideSwatches();
	}
}
function hideSwatches(){
	$("#overlaySwatchesDiv").css({visibility: "hidden"});
	$("#toolSwatches").css({background: "url('./ui/tools_swatches.png') no-repeat right center", color: "#4D4D4D"});
}
function sortFunc_ByLuminance(a, b){
	var aL = a.getLuminance();
	var bL = b.getLuminance();
	return bL-aL;
}
function sortFunc_BySaturation(a, b){
	var aL = a.getSaturation();
	var bL = b.getSaturation();
	return bL-aL;
}
function sortFunc_ByHue(a, b){
	var aL = a.getHue();
	var bL = b.getHue();
	return bL-aL;
}
function showCurrentSwatches(){
	computeSwatchesForCurrentPatch();
	$("#toolSwatches").css({background: "url('./ui/tools_close.png') no-repeat right center #4D4D4D", color: "#FFFFFF"});
	// now add the swatches to overlaySwatchesDiv
	var swatchesDiv = did("overlaySwatchesDiv");
	var swatchesHTML = "";
	for(var i=0; i<latestSwatches.length/8; i++){
		var swatch = latestSwatches[i*8];
		var x = Math.floor(swatch.origX/8);
		var y = Math.floor(swatch.origY/8);
		swatchesHTML += "<div class='swatch' title='"+swatch.getPrettyRGB()+", #"+swatch.getHex()+" -- Click for Pantone' onclick='loadPantoneColor(\""+swatch.getHex()+"\");' style='background: #"+swatch.getHex()+"; top: "+(y*80+10)+"px; left: "+(x*80+10)+"px;'></div>";
	}
	latestSwatches.sort(sortFunc_ByLuminance);
	for(var i=0; i<8; i++){
		var swatch = latestSwatches[i*128];
		swatchesHTML += "<div class='swatch' title='"+swatch.getPrettyRGB()+", #"+swatch.getHex()+" -- Click for Pantone' onclick='loadPantoneColor(\""+swatch.getHex()+"\");' style='background: #"+swatch.getHex()+"; width: 40px; height: 40px; top: 340px; left: "+(i*40+10)+"px;'></div>";
	}
	latestSwatches.sort(sortFunc_BySaturation);
	for(var i=0; i<8; i++){
		var swatch = latestSwatches[i*64];
		swatchesHTML += "<div class='swatch' title='"+swatch.getPrettyRGB()+", #"+swatch.getHex()+" -- Click for Pantone' onclick='loadPantoneColor(\""+swatch.getHex()+"\");' style='background: #"+swatch.getHex()+"; width: 40px; height: 40px; top: 380px; left: "+(i*40+10)+"px;'></div>";
	}
	/*
	latestSwatches.sort(sortFunc_ByHue);
	for(var i=0; i<8; i++){
		var swatch = latestSwatches[i*128];
		swatchesHTML += "<div class='swatch' title='"+swatch.getPrettyRGB()+", "+swatch.getHex()+"' style='background: "+swatch.getHex()+"; width: 40px; top: 394px; left: "+(i*40+10)+"px;'></div>";
	}
	 */
	
	swatchesDiv.innerHTML = swatchesHTML;
	$(swatchesDiv).css({visibility: "visible"});
	//latestSwatches
}
function loadPantoneColor(rgb){
	//window.location = "http://www.netfront.fr/Services/rgb2pantone/pantone.htm?r="+r+"&g="+g+"&b="+b;
	window.location = "http://www.netfront.fr/Services/rgb2pantone/pantone.htm?rgb="+rgb;
}
function computeSwatchesForCurrentPatch(){
	console.log("computing swatches...");
	// clear out previous swatches...
	latestSwatches = [];
	var canvas = document.getElementById("mainImageCanvas");
	var ctx = canvas.getContext("2d"); 
	var imgdata = ctx.getImageData(0, 0, $(canvas).width(), $(canvas).height());
	var GRID_PX = 32;
	var swatchImgData = ctx.createImageData(GRID_PX, GRID_PX);
	var w = imgdata.width;
	var h = imgdata.height;
	var wPx = Math.floor(w/GRID_PX);
	var hPx = Math.floor(h/GRID_PX);
	var pixels_per_cell = wPx*hPx;
	var idata = imgdata.data;
	for(var gx=0; gx<GRID_PX; gx++){
		for(var gy=0; gy<GRID_PX; gy++){
			var r = 0;
			var g = 0;
			var b = 0;
			var a = 0;
			var baseX = Math.floor(gx*(w/GRID_PX));
			var baseY = Math.floor(gy*(h/GRID_PX));
			for(var x=0; x<wPx; x++){
				for(var y=0;y<hPx; y++){
					var index = (baseX+x)*4 + (baseY+y)*w*4
					r += idata[index];
					g += idata[index+1];
					b += idata[index+2];
					a += idata[index+3];
				}
			}
			var avgR = Math.floor(r/pixels_per_cell);
			var avgG = Math.floor(g/pixels_per_cell);
			var avgB = Math.floor(b/pixels_per_cell);
			var avgA = Math.floor(a/pixels_per_cell);
			latestSwatches.push(new Swatch(gx, gy, avgR, avgG, avgB, avgA));
			var outputIndex = gx*4 + gy*GRID_PX*4;
			swatchImgData.data[outputIndex]   = avgR;
			swatchImgData.data[outputIndex+1] = avgG;
			swatchImgData.data[outputIndex+2] = avgB;
			swatchImgData.data[outputIndex+3] = 255; //avgA;
		}
	}
	console.log("done computing swatches.");
}

/*
const FILE_SIGNATURE : String = "ASEF";

function encode ( pixels : Array ):ByteArray
{
var swatch : ByteArray = new ByteArray();
var ase : ByteArray = new ByteArray();
var hex:String;
var pix:uint;

ase.writeUTFBytes (FILE_SIGNATURE);// header
ase.writeInt (0x10000);// version
ase.writeInt (pixels.length * 2);// blocks

for (var i : int = 0; i < pixels.length; ++i)
{
pix = pixels[i];
swatch.length = 0;

// start of group

ase.writeShort (0xC001);
ase.writeInt (0);
ase.writeShort (1);

// swatch name

hex = pix.toString(16);
while (hex.length < 6) hex = "0" + hex;

swatch.writeShort ((hex = "#" + hex).length + 1);
for (var n : int = 0; n < hex.length; ++n) swatch.writeShort (hex.charCodeAt(n));
swatch.writeShort (0);

// colours

swatch.writeUTFBytes ("RGB ");
swatch.writeFloat ((pix >> 16 & 0xFF) / 255);
swatch.writeFloat ((pix >> 8 & 0xFF) / 255);
swatch.writeFloat ((pix & 0xFF) / 255);
swatch.writeShort (2);

// write swatch

ase.writeInt (swatch.length);
ase.writeBytes (swatch);
}

return ase;
}

*/

function updateLoginSpecificElements(){
	if(auth_loggedIn){
		$("#requestMembershipSpan").css({display: "none"});
		$("#authErrorMessageDiv").css({display: "none"});
	}else{
		$("#authErrorMessageSpan").html(auth_errorMessage);
		if(auth_errorMessage.length == 0 || auth_alreadyListed){
			$("#requestMembershipSpan").css({display: "none"});
		}
	}
}
							
// this gets called as soon as the DOM is ready (faster than using 'onload').
$(document).ready(function(){
	  // required for using touch: setup touch with callback functions (defined above)...
	  //initTouch(touchStart, touchMove, touchEnd, touchCancel);
	  setTimeout(getUserData, 1000);
	  if(auto_refresh){
		  COMMENT_REFRESH_TIME = 5000;
		  setInterval(getUserData, 30000);
	  }
	  updateLoginSpecificElements();
	  document.hiddenImageUpload.reset();
	  setInterval(getCurrentPatchComments, COMMENT_REFRESH_TIME);
	  resizePageElements();
	  });

							
//]]>
</script>	

<script type="text/javascript" charset="utf-8">
var is_ssl = ("https:" == document.location.protocol);
var asset_host = is_ssl ? "https://s3.amazonaws.com/getsatisfaction.com/" : "http://s3.amazonaws.com/getsatisfaction.com/";
document.write(unescape("%3Cscript src='" + asset_host + "javascripts/feedback-v2.js' type='text/javascript'%3E%3C/script%3E"));
</script>

<script type="text/javascript" charset="utf-8">
var feedback_widget_options = {};

feedback_widget_options.display = "overlay";  
feedback_widget_options.company = "teague";
feedback_widget_options.placement = "hidden";
feedback_widget_options.color = "#222";
feedback_widget_options.style = "idea";

var feedback_widget = new GSFN.feedback_widget(feedback_widget_options);
</script>
							
<!-- ############################################# -->
<!-- ######## end of dynamic App content. ######## -->
<!-- ############################################# -->

<!-- You can put web stats code here -->
<script type="text/javascript">
var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
</script>
<script type="text/javascript">
try {
	var pageTracker = _gat._getTracker("UA-13029489-1");
	pageTracker._trackPageview();
} catch(err) {}</script>

</body>
</html>
