/* 
 License
 This program is free software; you can redistribute it and/or modify it 
 under the terms of the GNU General Public License as published by the 
 Free Software Foundation; either version 2 of the License, or (at your 
 option) any later version.
 This program is distributed in the hope that it will be useful, but 
 WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
 Public License for more details.
 
 */

/* So we can mix debug code in and not worry... */
if (!window.console) {
    window.console = {
	log: function () {},
	group: function () {},
	error: function () {},
	warn: function () {},
	groupEnd: function () {}
    };
}

var patchworkOpenID = document.PATCHWORK_OPEN_ID;
var patchworkEncodedOpenID = document.PATCH_ENCODED_ID;
var patchworkBaseURL = document.PATCH_BASE_URL;
var patchworkUsername = document.PATCH_USERNAME.replace("+", " ");

/*
console.log("PATCHWORK_OPEN_ID = " + document.PATCHWORK_OPEN_ID);
console.log("PATCH_ENCODED_ID = " + document.PATCH_ENCODED_ID);
console.log("PATCH_BASE_URL = " + document.PATCH_BASE_URL);
console.log("PATCH_USERNAME = " + document.PATCH_USERNAME);
*/

if(location.href.indexOf(patchworkBaseURL) < 0){
	
	// get the currently selected text
	var t = getSelectionHTML();

	var div = document.createElement("div");
	div.id = "patch_bookmarklet";
	div.style['border'] = "1px solid #000000"; 
	div.style['position'] = "fixed"; 
	div.style['_position'] = "absolute"; 
	div.style['top'] = "-1px"; 
	div.style['left'] = "-1px";
	div.style['zIndex'] = "100000"; 
	div.style['background'] = "#FFFFFF";
	div.style['paddingLeft'] = "50px";
	div.style['paddingRight'] = "50px";
	div.style['paddingBottom'] = "10px";
	div.style['paddingTop'] = "5px";
	div.style['margin'] = "0px";
	div.style['color'] = "#4D4D4D";
	div.style['fontSize'] = "12px";
	div.style['fontFamily'] = "Arial";
	div.style['textAlign'] = "Left"; // we don't want to be pushed to center!
	
	var divInnerHTML = ""; 
	divInnerHTML += "<span style='float: right; cursor: pointer;' onmousedown='closeBookmarklet();'>[close]</span>";
	divInnerHTML += "<span style='color: #4D4D4D;'>Patchwork Bookmarlet</span><br/><br/>";
	divInnerHTML += "<center>";
	divInnerHTML +=   "<div id='patch_image_nav_prev' onclick='showPatchImagePrev();' style='display: inline-block; margin-right: 10px; vertical-align: top; cursor: pointer; font-weight: 900; font-size: 16px; visibility: hidden;'>&lt;&lt;</div>";
	divInnerHTML +=   "<div id='patch_image_preview_container' style='display: inline-block; vertical-align: middle;'><img id='patch_image_preview' src='' style='width: 150px; height: auto; border: 1px #333333 solid;'/></div>";
	divInnerHTML +=   "<div id='patch_image_nav_next' onclick='showPatchImageNext();' style='display: inline-block; margin-left: 10px; vertical-align: top; cursor: pointer; font-weight: 900; font-size: 16px; visibility: hidden;'>&gt;&gt;</div>";
	divInnerHTML += "</center>";
	divInnerHTML += "<form>Image URL:<br/><input type='text' id='patch_input_imgURL' size='40' value='http://' style='height: 16px; width: 286px; color: #000000;' /><br/><br/>Title:<br/><input type='text' id='patch_input_title' size='40' value='' style='height: 16px; width: 286px; color: #000000;' /><br/><br/>Comment:<br/><input type='text' id='patch_input_desc' size='40' value='' style='height: 16px; width: 286px; color: #000000;'/><br/><br/><div style='position: relative;'>Post by: "+patchworkUsername+"<div style='background: #4D4D4D; color: #CCCCCC; text-align: center; height: 18px; padding-top: 3px; width: 100px; vertical-align: middle; position: absolute; top: -5px; left: 192px; cursor: pointer;' onmousedown='patch_submit();'>Submit</div></form></div>";
	
	div.innerHTML = divInnerHTML;
	
	function patch_submit(){
		patch_sendPageRequest();
		//alert("Submitted image to Patchwork -- Thanks! ");
	}

	var patch_xmlhttp;
	function patch_sendPageRequest(){
		if (window.XMLHttpRequest) { // code for Mozilla, Safari, and Now IE 7
			patch_xmlhttp = new XMLHttpRequest();
		}
		if (patch_xmlhttp != null && typeof(patch_xmlhttp)=='object') {
			patch_xmlhttp.onreadystatechange=patch_xmlHTTPReq;
			var url   = escape(location.href);
			var title = escape(document.getElementById('patch_input_title').value);
			var desc  = escape(document.getElementById('patch_input_desc').value);
			var imageURL = escape(document.getElementById('patch_input_imgURL').value);
			var username = escape(patchworkUsername);
			if(url == "" ){
				alert("\nPlease input a URL before submitting to Patchwork.\n\nThanks!\n");
				return;
			}
			patch_xmlhttp.open('GET', patchworkBaseURL+"xmlhttpreq/addNewPatch.php?url="+url+"&title="+title+"&desc="+desc+"&username="+username+"&imageURL="+imageURL+"&openID="+patchworkOpenID+"&encodedOpenID="+patchworkEncodedOpenID, true);
			patch_xmlhttp.send(null);
			alert("\nThanks for submitting an image to Patchwork.\n\nYour image should be posted within the next minute.\n\nIf your image does not appear, contact Patchwork for more details.\n\n");
			closeBookmarklet();
		}
	}

	function patch_xmlHTTPReq(){
		if (patch_xmlhttp.readyState==4) {
			// STATUS: 200 [valid web file], 0 [valid local file], 404 [page not found]
			if (patch_xmlhttp.status==200 || patch_xmlhttp.status == 0) {
				//alert("Response: " + patch_xmlhttp.status + " :: " + patch_xmlhttp.responseText);
				//console.log(patch_xmlhttp);
				//alert("Thanks for submitting an image to Patchwork."); // \n\n\nResponse: " + patch_xmlhttp.responseText);
				//closeBookmarklet();
			}else{
				// Unhappy :(
				alert("Could not load content from httpReqObject!\nStatus: "+patch_xmlhttp.status);
			}
		}else{
			//alert("Response ready state did not equal 4!");
		}
	}

	document.body.insertBefore(div, document.body.firstChild);

	var foundImage = false;
	var imageListIndex = 0;
	var allGoodImg = [];
	var firstImgIndex = t.toLowerCase().indexOf("img");
	if(firstImgIndex > 0){
		var imgStr = t.substr(firstImgIndex);
		console.log(imgStr);
		var imgEndIndex = imgStr.indexOf(">");
		if(imgEndIndex > 0){
			imgStr = imgStr.substr(0, imgEndIndex);
			console.log(imgStr);
			var srcStrIndex = imgStr.toLowerCase().indexOf("src=");
			if(srcStrIndex > 0){
				imgStr = imgStr.substr(srcStrIndex+4);
				var delimit = imgStr.substr(0,1);
				console.log(imgStr);
				imgStr = imgStr.substr(1);
				var endURLIndex = imgStr.indexOf(delimit);
				if(endURLIndex > 0){
					var imgURL = imgStr.substr(0,endURLIndex);
					console.log(imgURL);
					// WE HAVE THE URL NOW!
					var slashIndex = imgURL.indexOf("//");
					if(slashIndex < 0){
						// relative URL... append current location...
						var curLoc = location.href.substr(0, location.href.lastIndexOf("/")+1);
						if(imgURL.indexOf("/") == 0){
							console.log("Using URL base only...");
							curLoc = curLoc.substr(0, curLoc.substr(8).indexOf("/")+8);
							console.log(curLoc);
						}
						imgURL = curLoc + imgURL;
					}
					// use the imgURL!
					if(imgURL.length > 4){
						console.log(imgURL);
						document.getElementById("patch_image_preview").setAttribute("src", imgURL);
						var srcURL = document.getElementById("patch_image_preview").src
						document.getElementById("patch_input_imgURL").value = srcURL;
						allGoodImg.push(srcURL);
						foundImage = true;
					}
				}
			}
		}
	}
	if(!foundImage){
		// didn't find an image from the user's selection... let user cycle through all page images above a certain size.
		var allImg = document.getElementsByTagName('img');
		for(var i=0; i<allImg.length; i++){
			var img = allImg[i];
			if(img.width && img.width > 150 && img.height && img.height > 150 && img.id != "patch_image_preview"){
				var alreadyHaveIt = false;
				var newImgSrc = unescape(img.src);
				for(var m=0; m<allGoodImg.length; m++){
					if(allGoodImg[m] == newImgSrc){
						alreadyHaveIt = true;
					}
				}
				if(!alreadyHaveIt){
					allGoodImg.push(newImgSrc);
				}
			}
		}
		console.log(allGoodImg);
		if(allGoodImg.length > 0){
			// show a list of images.. starting with index 0.
			if(allGoodImg.length > 1){
				document.getElementById("patch_image_nav_next").style['visibility'] = "visible";
				document.getElementById("patch_image_nav_prev").style['visibility'] = "visible";
			}
			showPatchImage(0);
		}else{
			document.getElementById("patch_image_preview_container").innerHTML = "<br/><span style='color: #FF0000;'>No sizable images found on page.</span><br/></br><br/>";
		}
	}
	
	
	
}

function showPatchImage(i){
	if(i >= 0 && i < allGoodImg.length){
		document.getElementById("patch_image_nav_next").innerHTML = "&gt;&gt;<br/><span style='font-weight: 300; font-size: 12px;'>"+(i+1)+" / "+(allGoodImg.length)+"</span>";
		document.getElementById("patch_image_preview").setAttribute("src", allGoodImg[i]);
		document.getElementById("patch_input_imgURL").value = allGoodImg[i];
		imageListIndex = i;
	}
}
function showPatchImagePrev(){
	showPatchImage(imageListIndex-1);
}
function showPatchImageNext(){
	showPatchImage(imageListIndex+1);
}

function closeBookmarklet(){
	var patch = document.getElementById('patch_bookmarklet');
	patch.parentNode.removeChild(patch);
}

function getSelectionHTML() {
	var userSelection;
	if (window.getSelection) {
		// W3C Ranges
		userSelection = window.getSelection ();
		// Get the range:
		try{
			if (userSelection.getRangeAt)
				var range = userSelection.getRangeAt (0);
			else {
				var range = document.createRange ();
				range.setStart (userSelection.anchorNode, userSelection.anchorOffset);
				range.setEnd (userSelection.focusNode, userSelection.focusOffset);
			}
		}catch(e){
			return '';
		}
		// And the HTML:
		var clonedSelection = range.cloneContents ();
		var div = document.createElement ('div');
		div.appendChild (clonedSelection);
		return div.innerHTML;
	} else if (document.selection) {
		// Explorer selection, return the HTML
		userSelection = document.selection.createRange();
		return userSelection.htmlText;
	} else {
		return '';
	}
};
