// a single file that includes a set of common javascript libraries...

var TEAGUE_PROTO_VER = "10.08.09 -- No GMaps or MultiTouch";

function includeJavaScript(jsFile)
{
  document.write('<script src="' + jsFile + '"></scr'+'ipt>'); 
}

/* So we can mix debug code in and not worry... */
if (!window.console) {
    window.console = {
	log: function () {},
	group: function () {},
	error: function () {},
	warn: function () {},
	groupEnd: function () {}
    };
}
// sugared syntax for: document.getElementById(elName);
function did(elName){
	var el = document.getElementById(elName);
	if(el === null || el === undefined){
		console.warn("did: Tried to get undefined element. Name=" + elName);
	}
	return el;
}
// a helper for handling GPS navigation (pair with google maps to do cool stuff)...
function initNav(fnNavSuccess, fnNavError){
	var navGeo = navigator.geolocation;
	if (navGeo) {
		navGeo.getCurrentPosition(fnNavSuccess, fnNavError);
	} else {
		fnNavError('Geolocation not supported.');
	}	
}

// JQuery: tons of helpful functions, although the syntax can get a bit funky.. $("search pattern"), etc.
includeJavaScript("./js/jquery-1.4.2.min.js");

// HTML5 utils
includeJavaScript("./js/h5utils.js");

// allow multitouch based on mouse events (works with iphone, safari, and chrome).
//includeJavaScript("./js/multitouch-fake.js");

// simplify multitouch using classes and handling common touch functionality.
//includeJavaScript("./js/multitouch-simplifier.js");

// Google Maps API
//includeJavaScript("http://maps.google.com/maps/api/js?sensor=false");

console.log("Loaded TeagueProto.js >> version " + TEAGUE_PROTO_VER);


