<?php
	
	//----------------------------------------------------------------------------
	//
	// All software and media in this folder and its subdirectories 
	// is licensed as open source and creative commons respectively.
	//
	// Use it, make it better, and let others do the same. 
	//
	// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
	// Created as an internal project with Teague Labs (http://labs.teague.com)
	//
	// This program is free software: you can redistribute it and/or modify
	// it under the terms of the GNU General Public License as published by
	// the Free Software Foundation, either version 3 of the License, or
	// (at your option) any later version.
	
	// This program is distributed in the hope that it will be useful,
	// but WITHOUT ANY WARRANTY; without even the implied warranty of
	// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	// GNU General Public License for more details.
	//
	// You should have received a copy of the GNU General Public License
	// along with this program.  If not, see <http://www.gnu.org/licenses/>.
	//
	//----------------------------------------------------------------------------	
	
	require_once(dirname(__FILE__).'/../serverSettings.php');
	
	// this variable is used to indicate a successful login (unset = bad user, textdata = good user's openID).
	unset($auth_login); 
	
	unset($auth_errorMessage);
	$auth_fullname = "";
	$auth_email = "";
	$auth_openID = "";
	$auth_hadCookie = false;
	$auth_alreadyListed = false;
	if ($_COOKIE['login']) {
		list($c_username,$cookie_hash) = split(',',$_COOKIE['login']);
		if ($c_username != "" && md5($c_username.$SECRET_WORD) == $cookie_hash) {
			// everything checks out with the openID side of things...
			// now actually check to see if they are cleared to be here.
			$auth_hadCookie = true;
			$okayToUse = false;
			
			// make strings safe before passing them in as arguments to an SQL query.
			$safe_openID = makeSQLSafeString($c_username);
			
			try{
				// open the database and fetch the user. Note: this is called directly.
				$dbLocation = $DB_DIR.'openid.rdb';
				$dbHandle = new PDO('sqlite:'.$dbLocation);
				$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
				$query = "SELECT * FROM users WHERE openID = '".$safe_openID."'";
				$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query."). \n");
				if(!($row = $result->fetch())){	
					//not in the database yet.. add them as pending.
					$safe_openID_MD5 = makeSQLSafeString(md5($safe_openID));
					$safe_fullname = "";
					if($_COOKIE['fullname']){
						$safe_fullname = makeSQLSafeString($_COOKIE['fullname']);
					}
					$safe_email = "";
					if($_COOKIE['email']){
						$safe_email = makeSQLSafeString($_COOKIE['email']);
					}
					$ip = makeSQLSafeString($_SERVER['REMOTE_ADDR']);
					$curtime = time();
					$query2 = "INSERT INTO users (openID, openID_MD5, fullname, email, firstSeen, lastSeen, authStatus, lastIP) VALUES('".$safe_openID."', '".$safe_openID_MD5."', '".$safe_fullname."', '".$safe_email."', '".$curtime."', '".$curtime."', 'pending', '".$ip."') ";
					$result2 = $dbHandle->exec($query2) or die("\nQUERY ERROR:\n\nSQLite.query(".$query2."). \n");
					echo "\nYou are now pending membership.\n\nThe site's administrator will be notified of your request.\n\nThanks!";
				}else{
					echo "\nYour membership request has already been processed.\n\n Thanks!";
				}
			}catch(PDOException $exception){
				echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
				die("SQL Database Error: ".$exception->getMessage());
			}
		} else {
			echo "Shame. Shame. You have sent a bad cookie.";
		}
	}else{
		echo "\nYou have not logged in yet with your openID.\n\nPlease try to login before requesting membership.\n\nThanks!";
	}
	
?>
