<?php

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------	
	
require_once(dirname(__FILE__).'/../serverSettings.php');	
	
// this variable is used to indicate a successful login (unset = bad user, textdata = good user's openID).
unset($auth_login); 
	
unset($auth_errorMessage);
$auth_fullname = "";
$auth_email = "";
$auth_openID = "";
$auth_hadCookie = false;
$auth_alreadyListed = false;

$ip=$_SERVER['REMOTE_ADDR'];	
	
if ($_COOKIE['login']) {
	list($c_username,$cookie_hash) = split(',',$_COOKIE['login']);
	if ($c_username != "" && md5($c_username.$SECRET_WORD) == $cookie_hash) {
		// everything checks out with the openID side of things...
		// now actually check to see if they are cleared to be here.
		$auth_hadCookie = true;
		$okayToUse = false;
		
		// make strings safe before passing them in as arguments to an SQL query.
		$safe_openID = makeSQLSafeString($c_username);
		
		try{
			// open the database and fetch the user. Note: this is called from the parent directory.
			$dbLocation = $DB_DIR.'openid.rdb';
			//echo "//".$_SERVER['PHP_SELF']."\n";
			//echo "//".dirname(__FILE__)."\n";
			$dbHandle = new PDO('sqlite:'.$dbLocation);
			$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			$query = "SELECT * FROM users WHERE openID = '".$safe_openID."'";
			$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
			$temp_email = "<i>unknown</i>";
			if($_COOKIE['email']){
				$temp_email = "<i>".$_COOKIE['email']."</i>";
			}
			if($row = $result->fetch()){	
				$auth_alreadyListed = true;
				$authStatus = strtolower($row['authStatus']);
				switch($authStatus){
					case "pending":{
						$auth_errorMessage .= "<i>".$temp_email."</i> is pending membership.<br/>";
						$okayToUse = false;
						break;
					}
					case "banned":{
						$auth_errorMessage .= "Sorry. <i>".$temp_email."</i> has been denied access.<br/>";
						$okayToUse = false;
						break;
					}
					case "cleared":{
						// User is cleared -- yay!
						$okayToUse = true;
						break;
					}
					default: {
						$auth_errorMessage .= "Don't know user status... Talk to an admin.<br/>";
						$okayToUse = false;
						break;
					}
				}
				if($row = $result->fetch()){
					// there were multiple entries for this user!
					$auth_errorMessage .= "OH NO! -- Multiple entries for this user.<br/>";
					$okayToUse = false;
				}else{
					// only saw one user. go ahead and update info.
					$curTime = time();
					$result->fetchAll(); // clear out result before performing next query.
					$query2 = "UPDATE users SET lastSeen = '".$curTime."', lastIP = '".$ip."' WHERE openID = '".$safe_openID."'";
					$result2 = $dbHandle->exec($query2) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
				}
			}else{
				// didn't find user in database.
				$auth_errorMessage .= "Could not find login information for ".$temp_email.".<br/>";
			}
			
		}catch(PDOException $exception){
			$auth_errorMessage .= "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.<br/>";
			die("SQL Database Error: ".$exception->getMessage());
		}
		if($_COOKIE['email']){
			$auth_email = $_COOKIE['email'];
		}
		if($_COOKIE['fullname']){
			$auth_fullname = $_COOKIE['fullname'];
		}
		$auth_openID = $c_username;
		if($okayToUse){
			$auth_login = $c_username;
		}else{
			//$auth_errorMessage .= "Attempted to login, but remaining anonymous...";
		}
	} else {
		$auth_errorMessage .= "Shame. Shame. You have sent a bad cookie.";
	}
}

