<?php

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------
	
	require_once(dirname(__FILE__).'/serverSettings.php');

	$topMessage = "";
?>

<html>
<head><title><?php echo $WEBAPP_TYPE; ?> Admin</title></head>
<body onload='setTimeout(closeTopMessage, 5000);'>
<script type="text/javascript" src="./js/jquery-1.4.2.min.js"></script>
<script>
function closeTopMessage(){
	$("#topDivLastAction").animate({opacity: 0.0}, 'slow');
}
function checkVersion(){
	$.ajax({url: "./xmlhttpreq/getVersionLatestXML.php", success: function(data){
			// got version info.
			var infoArray = $(data).find("info");
			var version =  999;
			var note = "";
			if(infoArray.length > 0){
				version = parseFloat(unescape($(infoArray[0]).attr("version")));
				note = $(infoArray[0]).attr("note");
			}
			//alert(version);
			if(version > <?php echo $VERSION_NUM ?>){
				document.getElementById("topDivNewAvaiilable").innerHTML += "&nbsp; &mdash &nbsp;<b>Version "+version+" is now available <a href='<?php echo $WEBAPP_HOME_URL; ?>'>here</a>.</b>";
		   }else{
			   //alert("You have the latest version.");
		   }
		}, error: function(a,b,c){
		   // error, could not load version info.
		    document.getElementById("topDivNewAvaiilable").innerHTML += "&nbsp; &mdash &nbsp;<b>A new version may be available <a href='<?php echo $WEBAPP_HOME_URL; ?>'>here</a>.</b>";
		}});
}
</script>
<form style='display: none;' action='./serverAdmin.php' method='post' name='hiddenForm' id='hiddenForm'>
Username: <input type='text' name='uname' id='uname' /><br/>
Password: <input type='password' name='pword' id='pword' /><br/>
Serial: <input type='text' name='userSerial' id='userSerial' value='-1'/><br/>
AuthStatus: <input type='text' name='newAuthStatus' id='newAuthStatus' value='pending'/><br/>
Confirmation var: <input type='text' name='performAction' id='performAction' value='yes'/>
<button>Submit</button>
</form>
<div id='topDiv' style='width: 100%; background: #E6E6E6; color: #4D4D4D; text-align: center; padding-top: 5px; padding-bottom: 3px; font-size: 12px;' >
<div id='topDivTitle' style='border-bottom: 1px solid #B3B3B3; padding-top: 0px;'><center><h3><?php echo $WEBAPP_TYPE; ?> Server Admin</h3></center></div>
	<div id='topDivNewAvaiilable' style='color: #4D4D4D; padding-top: 5px;'>Version: <?php echo $VERSION_NUM; ?></div>
	<div id='topDivLastAction' style='color: #33AA33; padding-top: 5px;'>&nbsp;</div>
</div>

<?php
	if(!isset($_POST['uname']) || !isset($_POST['pword']) || !($_POST['uname'] == $ADMIN_USERNAME) || !($_POST['pword'] == $ADMIN_PASSWORD)){
		// Not logged in >> Show the admin login form.
		echo "Patchwork Admin login:";
		echo "<form action='./serverAdmin.php' method='post'>";
		echo "Username: <input type='text' name='uname' /><br/>";
		echo "Password: <input type='password' name='pword' /><br/>";
		echo "<button>Submit</button>";
		echo "</form>";
		exit;
	}else{
		// perform any requested actions...
		if(isset($_POST['performAction']) && isset($_POST['userSerial']) && isset($_POST['newAuthStatus'])){
			// perform action on userSerial by changing authSetting.
			$safe_userSerial = makeSQLSafeString($_POST['userSerial']);
			$safe_newAuthStatus = makeSQLSafeString($_POST['newAuthStatus']);
			$topMessage = "Tried to set new user auth status...";
			unset($dbHandle);
			if($safe_userSerial != "" && $safeUserSerial >= 0 && $safe_newAuthStatus != ""){
				try{
					// open the database and fetch the user. Note: this is called from the parent directory.
					$dbLocation = $DB_DIR.'openid.rdb';
					if(!$dbhandle){
						$dbHandle = new PDO('sqlite:'.$dbLocation);
						$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
					}
					$query = "SELECT * FROM users WHERE serial = '".$safe_userSerial."'";
					$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
					if($row = $result->fetch()){
						$result->fetchAll(); // clear out result before performing next query.
						$query2 = "UPDATE users SET authStatus = '".$safe_newAuthStatus."' WHERE serial = '".$safe_userSerial."'";
						$result2 = $dbHandle->exec($query2) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query2.").\n");
						$serial = $row['serial'];
						$fullname = $row['fullName'];
						$topMessage = "<b>$fullname</b> is now <b><i>$safe_newAuthStatus</i></b>.";
					}
				}catch(PDOException $exception){
					echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
					die("SQL Database Error: ".$exception->getMessage());
				}
			}
		}
			
// --------------------------------------------------------			
?>
<script>
function banUser(userSerial){
	document.getElementById('uname').value = '<?php echo $_POST['uname']; ?>';
	document.getElementById('pword').value = '<?php echo $_POST['pword']; ?>';
	document.getElementById('userSerial').value = userSerial;
	document.getElementById('newAuthStatus').value = "banned";
	document.hiddenForm.submit();
}
function clearUser(userSerial){
	document.getElementById('uname').value = '<?php echo $_POST['uname']; ?>';
	document.getElementById('pword').value = '<?php echo $_POST['pword']; ?>';
	document.getElementById('userSerial').value = userSerial;
	document.getElementById('newAuthStatus').value = "cleared";
	document.hiddenForm.submit();
}
</script>
<!-- successfully logged in! -->
<script>
checkVersion();
<?php 
	if($topMessage != ""){
		echo "$('#topDivLastAction').html('".$topMessage."');";
	}
?>
</script>
<br/>
<b>Current members</b><br/>
<table style='border: 1px solid #CCCCCC; width: 600px;' cellpadding='5px'>
<tr><td style='width: 200px;'>Name</td><td style='width: 200px;'>Email</td><td style='width: 100px;'>Status</td><td>Actions</td></tr>
<?php
	try{
		// open the database and fetch the user. Note: this is called from the parent directory.
		$dbLocation = $DB_DIR.'openid.rdb';
		if(!$dbhandle){
			$dbHandle = new PDO('sqlite:'.$dbLocation);
			$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		}
		$query = "SELECT * FROM users WHERE authStatus = 'cleared' ";
		$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
		while($row = $result->fetch()){
			$fullName = $row['fullName'];
			$email = $row['email'];
			$status = $row['authStatus'];
			echo "<tr><td>$fullName</td><td>$email</td><td style='color: #33BB33;'>$status</td><td style='color: #AA3333; cursor: pointer;' onclick='banUser(".$row['serial'].");' title='Remove user'><b>-</b></td></tr>\n";
		}
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
	
	?>
</table>

<br/><br/>
<b>Users requesting membership</b><br/>
<table style='border: 1px solid #CCCCCC; width: 600px;' cellpadding='5px'>
<tr><td style='width: 200px;'>Name</td><td style='width: 200px;'>Email</td><td style='width: 100px;'>Status</td><td colspan='2'>Actions</td></tr>
<?php
	try{
		// open the database and fetch the user. Note: this is called from the parent directory.
		$dbLocation = $DB_DIR.'openid.rdb';
		if(!$dbhandle){
			$dbHandle = new PDO('sqlite:'.$dbLocation);
			$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		}
		$query = "SELECT * FROM users WHERE authStatus = 'pending' ";
		$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
		while($row = $result->fetch()){
			$fullName = $row['fullName'];
			$email = $row['email'];
			$status = $row['authStatus'];
			echo "<tr><td>$fullName</td><td>$email</td><td style='color: #BB8833;'>$status</td><td style='color: #33AA33; cursor: pointer;' onclick='clearUser(".$row['serial'].");' title='Add user'><b>+</b></td><td style='color: #AA3333; cursor: pointer;' onclick='banUser(".$row['serial'].");' title='Remove user'><b>-</b></td></tr>\n";
		}
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
	
?>
</table>

<br/><br/>
<b>Users currently banned</b><br/>
<table style='border: 1px solid #CCCCCC; width: 600px;' cellpadding='5px'>
<tr><td style='width: 200px;'>Name</td><td style='width: 200px;'>Email</td><td style='width: 100px;'>Status</td><td>Actions</td></tr>
<?php
	try{
		// open the database and fetch the user. Note: this is called from the parent directory.
		$dbLocation = $DB_DIR.'openid.rdb';
		if(!$dbhandle){
			$dbHandle = new PDO('sqlite:'.$dbLocation);
			$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		}
		$query = "SELECT * FROM users WHERE authStatus = 'banned' ";
		$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
		while($row = $result->fetch()){
			$fullName = $row['fullName'];
			$email = $row['email'];
			$status = $row['authStatus'];
			echo "<tr><td>$fullName</td><td>$email</td><td style='color: #CC3333;'>$status</td><td style='color: #33AA33; cursor: pointer;' onclick='clearUser(".$row['serial'].");' title='Add user'><b>+</b></td></tr>\n";
		}
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
	
	?>
</table>



</body>
</html>
<?php
// --------------------------------------------------------			
	}
?>