<?php

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------
	
	require_once(dirname(__FILE__).'/../serverSettings.php');
	
	$errLog = "../logs/errorLog.txt";
	
	header("Content-Type:text/plain");  // PHP defaults to HTML header, so specify text/plain (or text/xml for XML doc).
	
	$ip=$_SERVER['REMOTE_ADDR'];
	if(!isset($_GET['patch']) || !isset($_GET['user']) || !isset($_GET['comment']) || !isset($_GET['openID']) || !isset($_GET['encodedOpenID']) ){
		echo "\nTo add a comment to a Patch, you must include a patch, user, comment, openID, and encodedOpenID. \n\nYour IP is " . $ip . "\n\n";
		$errHandle = fopen($errLog, 'a') or die("ERR: Can't open error Log.\n");
		fwrite($errHandle, time() . " :: " . "ERR >> addCommentToPatch.php >> Wrong arguments.  IP was " . $ip . ". \n");
		exit;
	}

	$openID        = urldecode($_GET['openID']);
	$encodedOpenID = urldecode($_GET['encodedOpenID']);
	$patch         = $_GET['patch'];
	$user          = $_GET['user'];
	$comment       = $_GET['comment'];
	
	
	// see if they are a valid user...
	if(md5($openID.$SECRET_WORD) != $encodedOpenID){
		echo "\nYour openID and encodedOpenID are not valid. \n\nLogging your IP (" . $ip . ") for transgression.\n\n";
		echo "openID: " . $openID . " \n";
		//echo "md5 w/ secret: " . md5($openID.$SECRET_WORD) . "\n";
		echo "encoded: " . $encodedOpenID . "\n";
		$errHandle = fopen($errLog, 'a') or die("ERR: Can't open error Log.\n");
		fwrite($errHandle, time() . " :: " . "ERR >> addCommentToPatch.php >> Invalid openID attempt.  IP was " . $ip . ". \n");
		exit;
	}
	
	$safe_openID = makeSQLSafeString($openID);
	$curTime = time();
	$safe_ip = makeSQLSafeString($ip);
	$safe_comment = makeSQLSafeString($comment);
	$safe_patchSerial = makeSQLSafeString($patch);
	
	try{
		// open the database and add patch. Note: this is called directly.
		$dbLocation = $DB_DIR.'patchwork.rdb';
		$dbHandle = new PDO('sqlite:'.$dbLocation);
		$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		// first test if patch exists...
		$query = "SELECT * FROM patches WHERE serial = '".$safe_patchSerial."'";
		$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
		if(!($row = $result->fetch())){	
			die("\nInvalid patch specified.\n");
		}
		$result->fetchAll(); // clear out result before performing next query.
		$query2 = "INSERT INTO comments (userOpenID, timeSubmitted, userIP, comment, withPatchSerial) VALUES('".$safe_openID."', '".$curTime."', '".$safe_ip."', '".$safe_comment."', '".$safe_patchSerial."' ) ";
		$result2 = $dbHandle->exec($query2) or die("\nQUERY ERROR:\n\nSQLite.query(".$query2."). \n\n");
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
	
	echo "Submitted comment to Patchwork -- Thanks!";

?>


