<?php

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------
	
	require_once(dirname(__FILE__).'/../serverSettings.php');

	$errLog = "../logs/errorLog.txt";
	
	header("Content-Type:text/plain");  // PHP defaults to HTML header, so specify text/plain (or text/xml for XML doc).
	
	$ip=$_SERVER['REMOTE_ADDR'];
	if(!isset($_GET['url']) || !isset($_GET['imageURL']) || !isset($_GET['title']) || !isset($_GET['desc']) || !isset($_GET['openID']) || !isset($_GET['encodedOpenID']) ){
		echo "\nTo add a Patch, you must include a url, imageURL, title, desc, openID, and encodedOpenID. \n\nYour IP is " . $ip . "\n\n";
		$errHandle = fopen($errLog, 'a') or die("ERR: Can't open error Log.\n");
		fwrite($errHandle, time() . " :: " . "ERR >> addNewPatch.php >> Wrong arguments.  IP was " . $ip . ". \n");
		exit;
	}
	
	$openID        = $_GET['openID'];
	$encodedOpenID = $_GET['encodedOpenID'];
	$url           = $_GET['url'];
	$title         = $_GET['title'];
	$desc          = $_GET['desc'];
	$user          = $_GET['username'];
	$imageURL      = $_GET['imageURL'];
	
	// see if they are a valid user...
	if(md5($openID.$SECRET_WORD) != $encodedOpenID){
		echo "\nYour openID and encodedOpenID are not valid. \n\nLogging your IP (" . $ip . ") for transgression.\n\n";
		echo "openID: " . $openID . " \n";
		//echo "md5 w/ secret: " . md5($openID.$SECRET_WORD) . "\n";
		echo "encoded: " . $encodedOpenID . "\n";
		$errHandle = fopen($errLog, 'a') or die("ERR: Can't open error Log.\n");
		fwrite($errHandle, time() . " :: " . "ERR >> addNewPatch.php >> Invalid openID attempt.  IP was " . $ip . ". \n");
		exit;
	}
	
	// their openID and encodedOpenID check out.. continue with adding the new Patch.
	
	$safe_openID = makeSQLSafeString($openID);
	$curTime = time();
	$safe_ip = makeSQLSafeString($ip);
	$safe_mediaURL = makeSQLSafeString($imageURL);
	$safe_title = makeSQLSafeString($title);
	$safe_contextURL = makeSQLSafeString($url);
	$safe_initReaction = makeSQLSafeString($desc);
	
	try{
		// open the database and add patch. Note: this is called directly.
		$dbLocation = $DB_DIR.'patchwork.rdb';
		$dbHandle = new PDO('sqlite:'.$dbLocation);
		$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$query = "INSERT INTO patches (userOpenID, timeSubmitted, userIP, mediaURL, contextURL, patchTitle, initialReaction) VALUES('".$safe_openID."', '".$curTime."', '".$safe_ip."', '".$safe_mediaURL."', '".$safe_contextURL."', '".$safe_title."', '".$safe_initReaction."' ) ";
		$result = $dbHandle->exec($query) or die("\nQUERY ERROR:\n\nSQLite.query(".$query."). \n\n");
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
	
	$errHandle = fopen($errLog, 'a') or die("ERR: Can't open error Log.\n");
	fwrite($errHandle, time() . " :: " . "OK  >> Submit Successful. imageURL= ".$imageURL." \n");
	echo "Submitted image to Patchwork -- Thanks!";
?>


