<?php

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------
	
	require_once(dirname(__FILE__).'/../serverSettings.php');
	
	header("Content-Type:text/xml"); 
	
	$ip=$_SERVER['REMOTE_ADDR'];
	if(!isset($_GET['patch'])){
		echo "\nYou must include a patch. \n\nYour IP is " . $ip . "\n\n";
		exit;
	}
	
	$patch   = $_GET['patch'];

	$safe_patchSerial = makeSQLSafeString($patch);
	
	try{
		// open the database and add patch. Note: this is called directly.
		$dbLocation = $DB_DIR.'patchwork.rdb';
		$dbHandle = new PDO('sqlite:'.$dbLocation);
		$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$dbLocation2 = $DB_DIR.'openid.rdb';
		$dbHandle2 = new PDO('sqlite:'.$dbLocation2);
		$dbHandle2->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		// first test if patch exists...
		$query = "SELECT * FROM comments WHERE withPatchSerial = '".$safe_patchSerial."'";
		$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
		echo "<comments>\n";
		while($row = $result->fetch()){	
			// reading in a comment.
			$safe_openID = makeSQLSafeString($row['userOpenID']);
			$username = "";
			$userMD5 = "";
			$query2 = "SELECT * FROM users WHERE openID = '".$safe_openID."'";
			$result2 = $dbHandle2->query($query2) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query2.").\n");
			if($row2 = $result2->fetch()){
				$username = $row2['fullName'];
				$userMD5 = $row2['openID_MD5'];
			}
			echo "<comment epoch='".$row['timeSubmitted']."' user='".urlencode($username)."' comment='".urlencode($row['comment'])."' userMD5='".$userMD5."'/>\n";
		}
		echo "</comments>";
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
?>