<?php

//----------------------------------------------------------------------------
//
// All software and media in this folder and its subdirectories 
// is licensed as open source and creative commons respectively.
//
// Use it, make it better, and let others do the same. 
//
// Copyright (C) 2010  Adam Kumpf (akumpf@teague.com) and Matt Wolfe
// Created as an internal project with Teague Labs (http://labs.teague.com)
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//----------------------------------------------------------------------------
	
	require_once(dirname(__FILE__).'/../serverSettings.php');
	
	header("Content-Type:text/xml"); 
	
	try{
		// open the database and add patch. Note: this is called directly.
		$dbLocation = $DB_DIR.'patchwork.rdb';
		$dbHandle = new PDO('sqlite:'.$dbLocation);
		$dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$dbLocation2 = $DB_DIR.'openid.rdb';
		$dbHandle2 = new PDO('sqlite:'.$dbLocation2);
		$dbHandle2->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		// first test if patch exists...
		$query = "SELECT * FROM patches ORDER BY serial ASC LIMIT 48";
		$result = $dbHandle->query($query) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query.").\n");
		echo "<patchlist>\n";
		while($row = $result->fetch()){	
			// reading in a comment.
			$safe_openID = $row['userOpenID'];
			$username = "";
			$userMD5 = "";
			$query2 = "SELECT * FROM users WHERE openID = '".$safe_openID."'";
			$result2 = $dbHandle2->query($query2) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query2.").\n");
			if($row2 = $result2->fetch()){
				$username = $row2['fullName'];
				$userMD5 = $row2['openID_MD5'];
			}
			$query3 = "SELECT * FROM comments WHERE withPatchSerial = '".$row['serial']."'";
			$result3 = $dbHandle->query($query3) or die("\nQUERY ERROR:\n<br/><br/>\nSQLite.query(".$query3.").\n");
			$numComments = count($result3->fetchAll());
			echo "<patch patchID='".$row['serial']."' epoch='".$row['timeSubmitted']."' url='".urlencode($row['contextURL'])."' imageURL='".urlencode($row['mediaURL'])."' title='".urlencode($row['patchTitle'])."' desc='".urlencode($row['initialReaction'])."' username='".urlencode($username)."' numComment='".$numComments."' userMD5='".$userMD5."'/>\n";
		}
		echo "</patchlist>";
	}catch(PDOException $exception){
		echo "DATABASE ERROR: make sure database file owner is set to '_www' and both directory/file have r/w permissions.";
		die("SQL Database Error: ".$exception->getMessage());
	}
	
	
	/*
	
	
	
	$urllist = "../db/patches.txt";
	
	$MAX_PATCHES_TO_RETURN = 24*3;
	
	if(file_exists($urllist)){
		//echo "FILE EXISTS!";
		//echo "<?xml version='1.0' encoding='UTF-8' >
		echo "<patchlist>\n";
		$lines = file($urllist);
		foreach ($lines as $line_num => $line) {
			if((count($lines)-$line_num) <= $MAX_PATCHES_TO_RETURN){
				$fullLink = split('>>DIV>>', rtrim($line));
				if(count($fullLink) == 7){
					$commentLines = -1;
					$commentFile = "../db/comments/comments_".$fullLink[0].".txt";
					if(file_exists($commentFile)){
						$commentLines = count(file($commentFile));
					}
					echo "    <patch epoch='".$fullLink[0]."' url='".$fullLink[1]."' imageURL='".$fullLink[2]."' title='".$fullLink[3]."' desc='".$fullLink[4]."' username='".$fullLink[5]."' numComments='".$commentLines."' userMD5='".$fullLink[6]."'/>\n";
				}
			}
		}
		echo "</patchlist>";
	}else{
		echo "<br/>Patches LIST DOES NOT EXIST.<br/><br/>";
	}
	 */
?>